<?php
/*
 ----------------------------------------------------------------------------+
|     e107 website system plugIn
|     http://e107.org
|     jalist@e107.org
|
|     Released under the terms and conditions of the
|     GNU General Public License (http://gnu.org).
|
|     $Source: /cvsroot/e107/e107_0.7/e107_plugins/registration/cConfig.php $
|     $Revision: 1.0 $
|	  $Created on 11.02.2009
|     $Date: 2009/02/11 $
|     $Author: mumm $
+----------------------------------------------------------------------------+
*/
@require_once("cDebugger.php"); 

class cConfig {
	

	
	private static $instance;
	protected $table="config";
	protected $debug=false; //toggles debug mode of this class
	protected $config;
	protected $error="";
	
			                     
	/**
	 * constructor is private
	 * use getInstance() to get a singleton class object
	 */
	protected function __construct(){	
		try{
			$this->initConfig();
		}
		catch(Exception $e){
			$this->exception_handler($e);
			$message=sprintf("%s: %s<p>%s!</p>",REG_REG_99, $e->getMessage(),REG_REG_100);
			exit($message);
		}		
	}
	
	/**
	 * clone is private -> singleton
	 * 
	 */
	private function __clone(){	}
	
	public function __destruct(){ }
		
			
	public function __get($property){
		$this->errorLog("Die Eigenschaft {$property} soll ausgelesen werden.\n");
	}
	
	public function __set($property, $value){
		$this->errorLog("Die Eigenschaft {$property} soll gesetzt werden.\n");
	}
	
	/**
	* @info class internal global exception handler 
	* @parameter: exception
	* @access private
	*/
	protected function exception_handler($exception) {
	  
	  $message  = sprintf("Nicht aufgefangene Exception: %s\n", $exception->getMessage());
	  $message .= sprintf("\t\tErrorCode: %s\n", $exception->getCode());
	  $message .= sprintf("\t\tDatei: %s\n", $exception->getFile());
	  $message .= sprintf("\t\tZeile: %s\n", $exception->getLine());
	  $message .= sprintf("\t\tTrace: %s\n\n", $exception->getTraceAsString());
	  $this->errorLog($message);
	}

	
	/**
	* @info debug method for listing content of arrays 
	* @parameter: array
	* @access private
	*/
	protected function debugArray($arr){
	
		//debug
		$content=sprintf("Array size %s, Content...\n",sizeof($arr));
		foreach($arr as $k => $v){
				$content.=sprintf("\t\t[%s]=%s\n", $k, $v);
		}
		$this->debug(sprintf("%s", $content));	
		
	}
	
	/**
	* @info debug method for listing all procedure calls 
	* @parameter: class var debug=true for detailed debug mode
	* @access private
	*/
	protected function debug($message){
	
		if(!$this->debug)return;
		$this->errorLog($message);
		
	}
	
	/**
	* @info errorLog method for listing all errors and exceptions 
	* @access private
	*/
	protected function errorLog($message){
	
		$message = sprintf("%s: %s", get_class($this),$message);
		cDebugger::getInstance()->debug($message);
		
	}
	
	
	//singleton
	public static function getInstance(){
		
		if(self::$instance == null) self::$instance= new cConfig();
		return self::$instance;
	}
		
	/**
	* @info shows the online register formular  
	* @access public
	*/	
	public function showConfig() {
		
		$text  =	sprintf("<form id='config' action='%s' method='post' enctype='multipart/form-data' onsubmit=''>", e_SELF);
		$text .=	sprintf("<table rules='all' style='%s;text-align:left;margin:5px;background:none; border:0;'>", USER_WIDTH);
		$text .=	$this->getInputPreferences();	
		
		$text .= "<tr><td colspan='3' style='text-align:left; border:0;padding-top:1em;' class='forumheader'>";
		$text .= sprintf("<input class='button' style='width:%s' type='submit'  value='%s' id='%s' name='%s' />","10em", REG_TOUR_2,"update","update");
		$text .= "</td></tr>";	
		$text .= "</table></form>";
				
		return $text;	
		
	}
	
	protected function initConfig(){
		
		//this are the standard data
		$this->config[v_sex]=0;
		$this->config[v_titel]=0;
		$this->config[v_level]=1;
		$this->config[m_level]=0;
		$this->config[v_verband]=1;//association view
		$this->config[m_verband]=1;
		$this->config[v_discount]=0;
		$this->config[v_accomodation]=0;
		$this->config[v_sideevent]=0;
		$this->config[v_helfer]=0;
		$this->config[v_gast]=1;//guest
		$this->config[v_plz]=1;
		$this->config[m_plz]=0;
		$this->config[v_phone1]=1;
		$this->config[m_phone1]=0;
		$this->config[v_country]=1;
		$this->config[m_country]=1;
		$this->config[v_adress]=1;
		$this->config[m_adress]=0;
		$this->config[v_phone2]=0;
		$this->config[v_remarks]=0;
		
		//if config Data in table take these data
		if(($data=$this->getConfigData())!=null)$this->config=$data;
		else $this->newConfig(); //otherwise init table data

	}
	
	/**
	* @info get config data ; db request 
	* @access private
	*/	
	protected function getConfigData(){
		
		try{
		
			global $sql;
			
			$data=array();
			$this->debug("DB select {$this->table}");
			
			$result=$sql->db_Select($this->table, "*" , "ORDER BY cfg_id DESC LIMIT 0,1", "");
			
			if(!$result) {
				$error=sprintf("DB Error %s: %s", mysql_errno(), mysql_error());
				if(mysql_errno()>0) throw new Exception ($error);
				$this->debug("Kein Datenbankeintrag gefunden");	
			}	
			
			if($row = $sql->db_Fetch())	{	
				foreach($row as $k => $v){
					if(strpos($k, "v_") === 0 || strpos($k, "m_") === 0 || strpos($k, "cfg_") === 0 )	{
						$data[$k]=$v;
					}
				}	
				
				//debug
				$this->debug(sprintf("DB result %s",$data));
				$this->debugArray($data);	
			}	
			
			return $data;
			
		}	
		catch(Exception $e){
			$this->exception_handler($e);
			$message=sprintf("%s: %s<p>%s!</p>",REG_REG_99, $e->getMessage(),REG_REG_100);
			exit($message);
		}
		
	}
	
	/**
	* @info get actual configuration for viewing and mandatories
	* @return array of named vars where pre v_ is for viewing 
	* and _m for mandatories   
	* @access public
	*/	
	public function getConfiguration(){
		
		return $this->config;		
	}
	
	/** @info updating config 
	* make sure only admin can access this method
	* the user id is requested and has to be provided 
	* @access public
	*/	
	public function updateConfig() {
		
		try {
			global $sql, $tp;  
			
			$actualConfig=$this->getConfigData();
			
			//receiving user input
			while(list($key, $value) = each($_POST)){
				
				foreach($_POST as $k => $v){
					if(strpos($k, "v_") === 0 || strpos($k, "m_") === 0 || strpos($k, "cfg_") === 0 ){
								$this->config[$k] = $tp->toDB($v);
					}			
				}
			}
								
			$this->config[cfg_update]	=	date("Y-m-d H:i:s");
			$this->config[cfg_updateip]	= 	$_SERVER['REMOTE_ADDR'];
			$this->config[cfg_updater]	= 	USERNAME;
			
			unset($this->config[cfg_id]);		
			$update=array();
			foreach($this->config as $k => $v)	$update[]=sprintf("%s='%s'",$k,$v);
			$cmd = implode(",",$update);
			$cmd .= sprintf(" WHERE cfg_id='%s'",$actualConfig[cfg_id]);
			
			$this->debug("DB update {$this->table}");
			$this->debug("SQL statement... \n\t{$cmd}\n");
			
			$result = $sql->db_Update($this->table, $cmd);
			if(!$result) {
				$error=sprintf("DB Error %s: %s", mysql_errno(), mysql_error());
				if(mysql_errno()>0) throw new Exception ($error);
				$this->debug("Update Eintrag nicht gefunden");				
			}	
			else $this->debug("Update erfolgreich");
			
			return $result;
			
		}	
		catch(Exception $e){
			$this->exception_handler($e);
			$message=sprintf("%s: %s<p>%s!</p>",REG_REG_99, $e->getMessage(),REG_REG_100);
			exit($message);
		}
		
	}
	
	/** @info new entry to db  
	* @variable using private array
	* @access public
	*/	
	protected function newConfig(){
		
		try{
			
			global $sql;
			
			//debug
			$this->debug("DB insert {$this->table}");
			$this->debugArray($this->config);
						
			$result = $sql->db_Insert($this->table, $this->config);
			
			
			if(!$result) {
					$error=sprintf("DB Error %s: %s", mysql_errno(), mysql_error());
					if(mysql_errno()>0) throw new Exception ($error);
			}	
				
			$this->debug("Insert erfolgreich");
				
			return $result;		
			
			
		}	
		catch(Exception $e){
			$this->exception_handler($e);
			$message=sprintf("%s: %s<p>%s!</p>",REG_REG_99, $e->getMessage(),REG_REG_100);
			exit($message);
		}
	}	
	
	/**
	* @info assembles the formular input 
	* this is open to public
	* @access private
	*/	
	protected function getInputPreferences() {
		
		
		$text="";
		$style1="width:15em; white-space:nowrap;padding:2px;vertical-align:middle;";//erste spalte
		$style2="width:2em; white-space:nowrap;padding:2px;vertical-align:top;text-align:left";//zweite spalte
		$anzeige=sprintf("checked='checked'");
		
		//tabellenkopf
		$text .= sprintf("<thead><tr>
							<th style='text-align:center;'>%s</th>
							<th style='text-align:center;padding:2px;'>%s</th>
							<th style='text-align:center;padding:2px;'>%s</th>
						</tr></thead>",REG_REG_54, REG_REG_55, REG_REG_56);
						
		
		//anrede
		$text .= sprintf("<tr>
							<td style='%s'>%s:</td>
							<td style='%s;'>
								<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_sex' id='sex1' %s value='1'><label for='sex1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_sex' id='sex2' %s value='0'><label for='sex2' style='vertical-align:middle;'>%s</label>
									</td>
								</tr></table>		
							</td>
							<td></td>		
						</tr>",$style1,REG_REG_5,$style2, ($this->config[v_sex]==1)?$anzeige:"",REG_REG_52, ($this->config[v_sex]==0)?$anzeige:"", REG_REG_53);
		
		//titel
		$text .= sprintf("<tr>
							<td style='%s'>%s:</td>
							<td style='%s;'>
								<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_titel' id='titel1'  %s value='1'><label for='titel1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_titel' id='titel2' %s value='0'><label for='titel2' style='vertical-align:middle;'>%s</label>
									</td>
								</tr></table>		
							</td>
							<td></td>		
						</tr>",$style1,REG_REG_6,$style2,($this->config[v_titel]==1)?$anzeige:"",REG_REG_52,($this->config[v_titel]==0)?$anzeige:"",REG_REG_53);				
		
		//level
		$text .= sprintf("<tr>
							<td style='%s'>%s:</td>
							<td style='%s;'>
								<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_level' id='level1' %s value='1'><label for='level1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_level' id='level2' %s value='0'><label for='level2' style='vertical-align:middle;'>%s</label>
									</td>
								</tr></table>
							</td>
							<td style='%s;'>
							<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='m_level' id='l1' %s value='1'><label for='l1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='m_level' id='l2' %s value='0'><label for='l2' style='vertical-align:middle;'>%s</label>
									</td>
								</tr></table>	
							</td>			
						  </tr>",$style1,REG_REG_7, $style2,
						   ($this->config[v_level]==1)?$anzeige:"",REG_REG_52,
						   ($this->config[v_level]==0)?$anzeige:"", REG_REG_53, 
						   $style2, 
						   ($this->config[m_level]==1)?$anzeige:"", REG_REG_52,
						   ($this->config[m_level]==0)?$anzeige:"", REG_REG_53);
					
		 //verband
		$text .= sprintf("<tr>
							<td style='%s;'>%s:</td>
							<td style='%s;'>
								<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_verband' id='verband1' %s value='1'><label for='verband1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_verband' id='verband2' %s value='0'><label for='verband2' style='vertical-align:middle;'>%s</label>
									</td>
								</tr></table>
							</td>
							<td style='%s;'>
							<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='m_verband' id='v1' %s value='1'><label for='v1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='m_verband' id='v2' %s value='0'><label for='v2' style='vertical-align:middle;'>%s</label>
									</td>
								</tr></table>	
							</td>			
						  </tr>",$style1,REG_REG_29, $style2,($this->config[v_verband]==1)?$anzeige:"",REG_REG_52,
						  ($this->config[v_verband]==0)?$anzeige:"",REG_REG_53, $style2,
						  ($this->config[m_verband]==1)?$anzeige:"",REG_REG_52, 
						  ($this->config[m_verband]==0)?$anzeige:"",REG_REG_53);
						  
		//discount
		$text .= sprintf("<tr>
							<td style='%s;'>%s:</td>
							<td style='%s;'>
								<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_discount' id='me1' %s value='1'><label for='me1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_discount' id='me2' %s value='0'><label for='me2' style='vertical-align:middle;'>%s</label>
									</td>
								</tr></table>
							</td><td></td>	
						  </tr>",$style1,REG_REG_25, $style2,
						   ($this->config[v_discount]==1)?$anzeige:"", REG_REG_52, 
						   ($this->config[v_discount]==0)?$anzeige:"", REG_REG_53);
		
		//sidevent
		$text .= sprintf("<tr>
							<td style='%s;'>%s:</td>
							<td style='%s;'>
								<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_sideevent' id='se1' %s value='1'><label for='se1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_sideevent' id='se2' %s value='0'><label for='se2' style='vertical-align:middle;'>%s</label>
									</td>
								</tr></table>
							</td><td></td>	
						  </tr>",$style1,REG_REG_22, $style2,
						  ($this->config[v_sideevent]==1)?$anzeige:"",REG_REG_52, 
						  ($this->config[v_sideevent]==0)?$anzeige:"",REG_REG_53);				  				  
		
		//unterkunft
		$text .= sprintf("<tr>
							<td style='%s;'>%s:</td>
							<td style='%s;'>
								<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_accomodation' id='a1' %s value='1'><label for='a1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_accomodation' id='a2' %s value='0'><label for='a2' style='vertical-align:middle;'>%s</label>
									</td>
								</tr></table>
							</td><td></td>	
						  </tr>",$style1,REG_REG_20, $style2,
						  ($this->config[v_accomodation]==1)?$anzeige:"",REG_REG_52, 
						  ($this->config[v_accomodation]==0)?$anzeige:"",REG_REG_53);	
		
		
		//helfer
		$text .= sprintf("<tr>
							<td style='%s;'>%s:</td>
							<td style='%s;'>
								<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_helfer' id='h1' %s value='1'><label for='h1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_helfer' id='h2' %s value='0'><label for='h2' style='vertical-align:middle;'>%s</label>
									</td>
								</tr></table>
							</td><td></td>	
						  </tr>",$style1,REG_REG_27, $style2,
						  ($this->config[v_helfer]==1)?$anzeige:"",REG_REG_52, 
						  ($this->config[v_helfer]==0)?$anzeige:"",REG_REG_53);		
						  
						  
		//gast
		$text .= sprintf("<tr>
							<td style='%s;'>%s:</td>
							<td style='%s;'>
								<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_gast' id='g1' %s value='1'><label for='g1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_gast' id='g2' %s value='0'><label for='g2' style='vertical-align:middle;'>%s</label>
									</td>
								</tr></table>
							</td><td></td>	
						  </tr>",$style1,REG_REG_28, $style2,
						  ($this->config[v_gast]==1)?$anzeige:"",REG_REG_52, 
						  ($this->config[v_gast]==0)?$anzeige:"",REG_REG_53);	
						  
		
		
		//plz
		$text .= sprintf("<tr>
							<td style='%s'>%s:</td>
							<td style='%s;'>
								<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_plz' id='plz1' %s value='1'><label for='plz1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_plz' id='plz2' %s value='0'><label for='plz2' style='vertical-align:middle;'>%s</label>
									</td>
									</tr></table>			
							</td>
							<td style='%s;'>
							<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='m_plz' id='mp1' %s value='1'><label for='mp1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='m_plz' id='mp2' %s value='0'><label for='mp2' style='vertical-align:middle;'>%s</label>
									</td>
								</tr></table>	
							</td>			
						  </tr>",$style1,REG_REG_13,$style2,
						   	($this->config[v_plz]==1)?$anzeige:"",REG_REG_52, 
						    ($this->config[v_plz]==0)?$anzeige:"",REG_REG_53, 
						     $style2,
						    ($this->config[m_plz]==1)?$anzeige:"",REG_REG_52, 
						    ($this->config[m_plz]==0)?$anzeige:"",REG_REG_53);
		
		//adresse
		$text .= sprintf("<tr>
							<td style='%s'>%s:</td>
							<td style='%s;'>
								<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_adress' id='add1' %s value='1'><label for='add1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_adress' id='add2' %s value='0'><label for='add2' style='vertical-align:middle;'>%s</label>
									</td>
									</tr></table>			
							</td>
							<td style='%s;'>
							<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='m_adress' id='ma1' %s value='1'><label for='ma1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='m_adress' id='ma2' %s value='0'><label for='ma2' style='vertical-align:middle;'>%s</label>
									</td>
								</tr></table>	
							</td>			
						  </tr>",$style1,REG_REG_15,$style2,
						  ($this->config[v_adress]==1)?$anzeige:"",REG_REG_52, 
						    ($this->config[v_adress]==0)?$anzeige:"",REG_REG_53, 
						     $style2,
						    ($this->config[m_adress]==1)?$anzeige:"",REG_REG_52, 
						    ($this->config[m_adress]==0)?$anzeige:"",REG_REG_53);
		
		//land
		$text .= sprintf("<tr>
							<td style='%s'>%s:</td>
							<td style='%s;'>
								<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_country' id='land1' %s value='1'><label for='land1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_country' id='land2' %s value='0'><label for='land2' style='vertical-align:middle;'>%s</label>
									</td>
									</tr></table>			
							</td>
							<td style='%s;'>
							<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='m_country' id='ml1' %s value='1'><label for='ml1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='m_country' id='ml2' %s value='0'><label for='ml2' style='vertical-align:middle;'>%s</label>
									</td>
								</tr></table>	
							</td>			
						  </tr>",$style1,REG_REG_12,$style2,
						  ($this->config[v_country]==1)?$anzeige:"",REG_REG_52, 
						    ($this->config[v_country]==0)?$anzeige:"",REG_REG_53, 
						     $style2,
						    ($this->config[m_country]==1)?$anzeige:"",REG_REG_52, 
						    ($this->config[m_country]==0)?$anzeige:"",REG_REG_53);
						  
		//telefon1
		$text .= sprintf("<tr>
							<td style='%s'>%s:</td>
							<td style='%s;'>
								<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_phone1' id='fon1' %s value='1'><label for='fon1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_phone1' id='fon2' %s value='0'><label for='fon2' style='vertical-align:middle;'>%s</label>
									</td>
									</tr></table>			
							</td>
							<td style='%s;'>
							<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='m_phone1' id='mf1' %s value='1'><label for='mf1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='m_phone1' id='mf2' %s value='0'><label for='mf2' style='vertical-align:middle;'>%s</label>
									</td>
								</tr></table>	
							</td>			
						  </tr>",$style1,REG_REG_17,$style2,
						  	($this->config[v_phone1]==1)?$anzeige:"",REG_REG_52, 
						    ($this->config[v_phone1]==0)?$anzeige:"",REG_REG_53, 
						     $style2,
						    ($this->config[m_phone1]==1)?$anzeige:"",REG_REG_52, 
						    ($this->config[m_phone1]==0)?$anzeige:"",REG_REG_53);
		
		//telefon2
		$text .= sprintf("<tr>
							<td style='%s'>%s:</td>
							<td style='%s;'>
								<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_phone2' id='fon3' %s value='1'><label for='fon3' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_phone2' id='fon4' %s value='0'><label for='fon4' style='vertical-align:middle;'>%s</label>
									</td>
									</tr></table>			
							</td><td></td>
						  </tr>",$style1,REG_REG_18,$style2,
						  ($this->config[v_phone2]==1)?$anzeige:"",REG_REG_52, 
						    ($this->config[v_phone2]==0)?$anzeige:"",REG_REG_53);
		
		//bemerkung
		$text .= sprintf("<tr>
							<td style='%s'>%s:</td>
							<td style='%s;'>
								<table style='margin=0;padding:0;border:0'><tr>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_remarks' id='txt1' %s value='1'><label for='txt1' style='vertical-align:middle;'>%s</label>
									</td>
									<td style='vertical-align:top;padding-right:1em;'>
										<input style='vertical-align:middle' type='radio' name='v_remarks' id='txt2' %s value='0'><label for='txt2' style='vertical-align:middle;'>%s</label>
									</td>
									</tr></table>			
							</td><td></td>
						  </tr>",$style1,REG_REG_19,$style2,
						  ($this->config[v_remarks]==1)?$anzeige:"",REG_REG_52, 
						    ($this->config[v_remarks]==0)?$anzeige:"",REG_REG_53);
		
						  				  				  
		
																																																		
		return $text;
		
	
	}
	
	
	
	
}

?>
