<?php
/*
 ----------------------------------------------------------------------------+
|     e107 website system plugIn
|     http://e107.org
|     jalist@e107.org
|
|     Released under the terms and conditions of the
|     GNU General Public License (http://gnu.org).
|
|     $Source: /cvsroot/e107/e107_0.7/e107_plugins/registration/cMail.php $
|     $Revision: 1.0 $
|	  $Created on 11.02.2009
|     $Date: 2009/02/11 $
|     $Author: mumm $
+----------------------------------------------------------------------------+
*/
@require_once("cDebugger.php"); 
@require_once(e_HANDLER."mail.php");
@require_once e_PLUGIN.'registration/languages/'.e_LANGUAGE.'.php';
@require_once e_PLUGIN.'registration/languages/Deutsch.php';

class cMail {
	

	
	private static $instance;
	protected $table="email";
	protected $config;
	protected $error="";
	protected $debug=false; //toggles debug mode of this class
	
			                     
	/**
	 * constructor is private
	 * use getInstance() to get a singleton class object
	 */
	protected function __construct(){
		
		try{
			$this->debug("Construct");
			$this->init();
		}
		catch(Exception $e){
			$this->exception_handler($e);
			$message=sprintf("%s: %s<p>%s!</p>",REG_REG_99, $e->getMessage(),REG_REG_100);
			exit($message);
		}
	}
	
	/**
	 * clone is private -> singleton
	 * 
	 */
	private function __clone(){	}
	
	public function __destruct(){ }
	
				
	public function __get($property){
		$this->errorLog("Die Eigenschaft {$property} soll ausgelesen werden.\n");
	}
	
	public function __set($property, $value){
		$this->errorLog("Die Eigenschaft {$property} soll gesetzt werden.\n");
	}
	
	/**
	* @info class internal global exception handler 
	* @parameter: exception
	* @access private
	*/
	protected function exception_handler($exception) {
	  
	  $message  = sprintf("Nicht aufgefangene Exception: %s\n", $exception->getMessage());
	  $message .= sprintf("\t\tErrorCode: %s\n", $exception->getCode());
	  $message .= sprintf("\t\tDatei: %s\n", $exception->getFile());
	  $message .= sprintf("\t\tZeile: %s\n", $exception->getLine());
	  $message .= sprintf("\t\tTrace: %s\n\n", $exception->getTraceAsString());
	  $this->errorLog($message);
	}

	
	/**
	* @info debug method for listing content of arrays 
	* @parameter: array
	* @access private
	*/
	protected function debugArray($arr){
	
		//debug
		$content=sprintf("Array size %s, Content...\n",sizeof($arr));
		foreach($arr as $k => $v){
				$content.=sprintf("\t\t[%s]=%s\n", $k, $v);
		}
		$this->debug(sprintf("%s", $content));	
		
	}
	
	/**
	* @info debug method for listing all procedure calls 
	* @parameter: class var debug=true for detailed debug mode
	* @access private
	*/
	protected function debug($message){
	
		if(!$this->debug)return;
		$this->errorLog($message);
		
	}
	
	/**
	* @info errorLog method for listing all errors and exceptions 
	* @access private
	*/
	protected function errorLog($message){
	
		$message = sprintf("%s: %s", get_class($this),$message);
		cDebugger::getInstance()->debug($message);
		
	}
	
	
	//singleton
	public static function getInstance(){
		
		if(self::$instance == null) self::$instance= new cMail();
		return self::$instance;
	}
	
	/**
	* @info init all config data and starts frist time database saving 
	* @access private
	*/
	protected function init(){
		
		
		//this are the standard data
		$this->config[reg_mail]=1;
		$this->config[reg_data]=1;
		$this->config[reg_subject]=REG_REG_77;
		$this->config[reg_name]=REG_REG_78;
		$this->config[reg_abs]=REG_REG_79;
		$this->config[reg_cc]="";
		$this->config[reg_bcc]="";
		$this->config[reg_url]="";
		
		
		//if config Data in table take these data
		if(($data=$this->getConfigData())!=null)$this->config=$data;
		else $this->newConfig(); //otherwise init table data

	}
	
	/**
	* @info get config data ; db request 
	* @access private
	*/	
	protected function getConfigData(){
		
		try {
			global $sql;
			
			$data=array();
			$this->debug("DB select {$this->table}");
			
			$result=$sql->db_Select($this->table, "*" , "ORDER BY reg_id DESC LIMIT 0,1", "");
			if(!$result) {
					$error=sprintf("DB Error %s: %s", mysql_errno(), mysql_error());
					if(mysql_errno()>0) throw new Exception ($error);
					$this->debug("Kein Datenbankeintrag gefunden");	
			}	
			
				
			if($row = $sql->db_Fetch())	{	
				
				foreach($row as $k => $v){
							
					if(strpos($k, "reg_") === 0)	{
						$data[$k]=$v;
					}
				}
				//debug
				$this->debug(sprintf("DB result %s",$data));
				$this->debugArray($data);		
			}	
			
			
			return $data;
			
		}
		catch(Exception $e){
			$this->exception_handler($e);
			$message=sprintf("%s: %s<p>%s!</p>",REG_REG_99, $e->getMessage(),REG_REG_100);
			exit($message);
		}		
	}
	
		
	/** @info new entry to db  
	* @variable using private array
	* @access public
	*/	
	protected function newConfig(){
		
		try {
			global $sql;
			
			//debug
			$this->debug("DB insert {$this->table}");
			$this->debugArray($this->config);
						
			$result = $sql->db_Insert($this->table, $this->config);
			
			if(!$result) {
					$error=sprintf("DB Error %s: %s", mysql_errno(), mysql_error());
					if(mysql_errno()>0) throw new Exception ($error);
			}	
				
			$this->debug("Insert erfolgreich");
				
			return $result;		
				
		}
		catch(Exception $e){
			$this->exception_handler($e);
			$message=sprintf("%s: %s<p>%s!</p>",REG_REG_99, $e->getMessage(),REG_REG_100);
			exit($message);
		}		
	}	
	
		
	/**
	* @info get actual configuration for email confirmation
	* @return array of named vars 
	* @access public
	*/	
	public function getConfiguration(){
		
		return $this->config;		
	}
	
	/** @info updating config 
	* make sure only admin can access this method
	* the user id is requested and has to be provided 
	* @access public
	*/	
	public function updateConfig() {
		
		try {
			
			global $sql, $tp;  
			
			$actualConfig=$this->getConfigData();
			
			//receiving user input
			while(list($key, $value) = each($_POST)){
				
				foreach($_POST as $k => $v){
					if(strpos($k, "reg_") === 0){
								$this->config[$k] = $tp->toDB($v);
					}			
				}
			}
								
			$this->config[reg_update]	=	date("Y-m-d H:i:s");
			$this->config[reg_updateip]	= 	$_SERVER['REMOTE_ADDR'];
			$this->config[reg_updater]	= 	USERNAME;
			
			//VALIDATE
			if(!$this->validateInput()) return;
			
			unset($this->config[reg_id]);		
			$update=array();
			foreach($this->config as $k => $v)	$update[]=sprintf("%s='%s'",$k,$v);
			$cmd = implode(",",$update);
			$cmd .= sprintf(" WHERE reg_id='%s'",$actualConfig[reg_id]);
			
				
			$this->debug("DB update {$this->table}");
			$this->debug("SQL statement... \n\t{$cmd}\n");
			
			$result = $sql->db_Update($this->table, $cmd);
			if(!$result) {
				$error=sprintf("DB Error %s: %s", mysql_errno(), mysql_error());
				if(mysql_errno()>0) throw new Exception ($error);
				$this->debug("Update Eintrag nicht gefunden");				
			}	
			else $this->debug("Update erfolgreich");
			
			return $result;
		}
		catch(Exception $e){
			$this->exception_handler($e);
			$message=sprintf("%s: %s<p>%s!</p>",REG_REG_99, $e->getMessage(),REG_REG_100);
			exit($message);
		}	
	}
	
	
	/**
	* @info validating input of config data 
	* @access private
	*/
	protected function validateInput(){
		
		$msg=array();
		
		//name  
		if(strlen(trim($this->config[reg_name]))==0)
			$msg[]=sprintf("%s", REG_REG_69);
		
		//subject
		if(strlen(trim($this->config[reg_subject]))==0)
			$msg[]=sprintf("%s",REG_REG_72);
			
		//abs email
		if(strlen(trim($this->config[reg_abs]))==0 || !$this->isEmailValid(trim($this->config[reg_abs])))
			$msg[]=sprintf("%s",REG_REG_68);
		
		//cc_email
		if(strlen(trim($this->config[reg_cc]))>0 && !$this->isEmailValid(trim($this->config[reg_cc])))
			$msg[]=sprintf("%s",REG_REG_70);
		
		//bcc_email
		if(strlen(trim($this->config[reg_bcc]))>0 && !$this->isEmailValid(trim($this->config[reg_bcc])))
			$msg[]=sprintf("%s",REG_REG_71);
		
		
			
		$this->error=implode(", ",$msg);
		
		$res=strlen($this->error)==0;
		$this->debug(sprintf("Validating %s",$res?"TRUE":"FALSE"));		
		
		return $res;
		
	}
	
	
	/**
	* @info proof if given email format is correct 
	* @access private
	*/	
	protected function isEmailValid($allEmail){
		
		$emailArray = explode(",",$allEmail);
		
		$mailpattern = "#^[-!\#$%&\"*+\\./\d=?A-Z^_|'a-z{|}~]+" .
			"@".
			"[-!\#$%&\"*+\\./\d=?A-Z^_|'a-z{|}~]+\." .
			"[-!\#$%&\"*+\\./\d=?A-Z^_|'a-z{|}~]+$#";
			
		foreach($emailArray as $email){
				if(!preg_match($mailpattern,trim($email))) return false;
				
			}
		
		
				
		return true;
	
	}
	
	/**
	* @info shows a config table for easy editing general mail data
	* @info this is for admins only 
	* @access public
	*/
	public function showConfig(){
			
		$anzeige=sprintf("checked='checked'");
		$text = sprintf("
   							
   							<form action='%s' method='post' id='turnierform' enctype='multipart/form-data'> 
   							<table class='fborder' style='%s'>",e_SELF,	ADMIN_WIDTH);
   		
   		//email besttigung
   		$text .= sprintf("	
   							<tr>
								<td class='forumheader3' style='width:30%%; font-weight:bold; white-space:nowrap;'>%s</td>
								<td class='forumheader3' style='white-space:nowrap;padding:4px;vertical-align:top;text-align:left;width:70%%;'>
										<table align='left' style='margin=0;padding:0;border:0; text-align:left'><tr>
											<td style='vertical-align:top;padding-right:1em;text-align:left'>
												<input style='vertical-align:middle' type='radio' name='reg_mail' id='mail1' %s value='1'><label for='mail1' style='vertical-align:middle;'>%s</label>
											</td>
											<td style='vertical-align:top;padding-right:1em;text-align:left'>
												<input style='vertical-align:middle' type='radio' name='reg_mail' id='mail2' %s value='0'><label for='mail2' style='vertical-align:middle;'>%s</label>
											</td>
									</tr></table>		
								</td>
							</tr>", REG_REG_66, ($this->config[reg_mail]==1)?$anzeige:"", REG_REG_52, ($this->config[reg_mail]==0)?$anzeige:"", REG_REG_53);
		
		//email register data
   		$text .= sprintf("	
   							<tr>
								<td class='forumheader3' style='width:30%%; font-weight:bold; white-space:nowrap;'>%s</td>
								<td class='forumheader3' style='white-space:nowrap;padding:4px;vertical-align:top;text-align:left;width:70%%;'>
										<table align='left' style='margin=0;padding:0;border:0; text-align:left'><tr>
											<td style='vertical-align:top;padding-right:1em;text-align:left'>
												<input style='vertical-align:middle' type='radio' name='reg_data' id='data1' %s value='1'><label for='data1' style='vertical-align:middle;'>%s</label>
											</td>
											<td style='vertical-align:top;padding-right:1em;text-align:left'>
												<input style='vertical-align:middle' type='radio' name='reg_data' id='data2' %s value='0'><label for='data2' style='vertical-align:middle;'>%s</label>
											</td>
									</tr></table>		
								</td>
							</tr>", REG_REG_67, ($this->config[reg_data]==1)?$anzeige:"", REG_REG_52, ($this->config[reg_data]==0)?$anzeige:"", REG_REG_53);
		
		//betreff
		
		$text .= sprintf("						
   							<tr>
								<td class='forumheader3' style='width:30%%; font-weight:bold; white-space:nowrap;'>%s</td>
								<td class='forumheader3' style='width:70%%;'><input name='reg_subject' type='text' size='50' maxlength='80' value='%s'></td>
							</tr>",REG_REG_72,$this->config[reg_subject] );
		
		
		
		//absender Name
		$text .= sprintf("						
   							<tr>
								<td class='forumheader3' style='width:30%%; font-weight:bold; white-space:nowrap;'>%s</td>
								<td class='forumheader3' style='width:70%%;'><input name='reg_name' title='%s' type='text' size='50' maxlength='80' value='%s'></td>
							</tr>",REG_REG_69, REG_REG_76 ,$this->config[reg_name]);
							
		//absender email
		$text .= sprintf("						
   							<tr>
								<td class='forumheader3' style='width:30%%; font-weight:bold; white-space:nowrap;'>%s</td>
								<td class='forumheader3' style='width:70%%;'><input name='reg_abs' title='%s' type='text' size='80' maxlength='200' value='%s'></td>
							</tr>",REG_REG_68, REG_REG_73,$this->config[reg_abs]);
		
		//cc email
		$text .= sprintf("						
   							<tr>
								<td class='forumheader3' style='width:30%%; font-weight:bold; white-space:nowrap;'>%s</td>
								<td class='forumheader3' style='width:70%%;'><input name='reg_cc' title='%s' type='text' size='80' maxlength='200' value='%s'></td>
							</tr>",REG_REG_70, REG_REG_74,$this->config[reg_cc]);					
							
		//bcc email
		$text .= sprintf("						
   							<tr>
								<td class='forumheader3' style='width:30%%; font-weight:bold; white-space:nowrap;'>%s</td>
								<td class='forumheader3' style='width:70%%;'><input name='reg_bcc' title='%s' type='text' size='80' maxlength='200' value='%s'></td>
							</tr>",REG_REG_71, REG_REG_75,$this->config[reg_bcc]);	
		
		//url
		$text .= sprintf("						
   							<tr>
								<td class='forumheader3' style='width:30%%; font-weight:bold; white-space:nowrap;'>%s</td>
								<td class='forumheader3' style='width:70%%;'><input name='reg_url' title='%s' type='text' size='80' maxlength='200' value='%s'></td>
							</tr>",REG_REG_87, REG_REG_88,$this->config[reg_url]);						
		
		//button
		$text .= sprintf("</table>
							<div style='margin:1em;text-align:center;'><input class='button' style='width:10em' type='submit'  value='%s' id='%s' name='%s' /></div>
						 </form>", REG_TOUR_2,"update","update");
							
		
		//Fehlermeldung
		$text .= sprintf("<div style='text-align:left;color:red;margin:15px 0 0 0'>%s</div>		
							
		   				", $this->error);   		
   					
   				
   		return $text;		
	
	}
	
	/**
	* @info assembling all registration data for confirmation mail
	* @parameter known array of parcipitaion data assembled by Class cRegister
	* @return string 
	* @access privat
	*/
	protected function getRegisterText($teilnehmer){
		
					$config = cConfig::getInstance()->getConfiguration();
				             
					$amn_text =  sprintf("\n\n%s:\n\n", REG_REG_84);
					
					$name= sprintf("%s %s %s, %s",$teilnehmer[reg_sex] ,$teilnehmer[reg_titel], $teilnehmer[reg_name], $teilnehmer[reg_vorname]); 
					$amn_text .=  sprintf("\t\t%s:\t%s\n", REG_REG_34, trim($name));
					
					if($config[v_adress]==1 || $config[v_plz]==1){
		            	$amn_text .=  sprintf("\t\t%s:\t%s, %s %s\n",REG_REG_86, $teilnehmer[reg_adress], $teilnehmer[reg_plz], $teilnehmer[reg_city]);
					}
		            
		            //Land
		            if($config[v_country]==1){
		            	$amn_text .=  sprintf("\t\t%s:\t%s\n", REG_REG_12,$teilnehmer[reg_country]);
		            }	
		            
		            //email
		            $amn_text .=  sprintf("\t\t%s:\t%s\n", REG_REG_16, $teilnehmer[reg_email]);
		            
		            if($config[v_phone1]==1 ){
		            	$amn_text .=  sprintf("\t\t%s:\t%s\n", REG_REG_17, $teilnehmer[reg_phone1]);
		            }
		            if($config[v_phone2]==1 ){	
		            	$amn_text .=  sprintf("\t\t%s:\t%s\n", REG_REG_18, $teilnehmer[reg_phone2]);
		            }	 
		            
		            //rank
		            if($config[v_level]==1){
			            //calculate rank
						if($teilnehmer[reg_level]>0)  $rank= $teilnehmer[reg_level] ."D";
						else $rank=abs($teilnehmer[reg_level]).'k';
						$amn_text .=  sprintf("\t\t%s:\t%s\n", REG_REG_81,$rank);
		            }
		            
		            if($config[v_verband]==1 ){	
						$amn_text .=  sprintf("\t\t%s:\t%s\n",REG_REG_29, $teilnehmer[reg_verband]);
		            }
		            
		            //club
					$amn_text .=  sprintf("\t\t%s:\t%s\n\n",REG_REG_85, $teilnehmer[reg_city]);
		            
					
					//teilnahme
					switch($teilnehmer[reg_teilnahme]){
						case 2: $teilname=sprintf("%s", REG_REG_27);break;
						case 3: $teilname=sprintf("%s", REG_REG_28);break;
						default:$teilname=sprintf("%s",REG_REG_26);
					}
					$amn_text .=  sprintf("\t\t%s:\t%s\n", REG_REG_80,$teilname);
					
					$amn_text .=  sprintf("\t\t%s:\t%s\n", REG_REG_21,($teilnehmer[reg_mainevent]?"X":"0"));
					
					//sideevent
					if($config[v_sideevent]==1 ){
						$amn_text .=  sprintf("\t\t%s:\t%s\n",REG_REG_22, ($teilnehmer[reg_sideevent]?"X":"0"));
					}	

					//Rabatt
					if($teilnehmer[reg_discount]){
						switch(reg_discounttype){
							case 1:$discount=sprintf("%s", REG_REG_82);break;
							case 2:$discount=sprintf("%s", REG_REG_24);
							default:$discount=sprintf("--");
						}
						$amn_text .=  sprintf("\t\t%s:\t%s\n",REG_REG_83, $discount);
					}
					
					//Unterkunft
					if($config[v_accomodation]==1){							
		            	$amn_text .=  sprintf("\t\t%s:\t%s\n",REG_REG_20, ($teilnehmer[reg_accomodation]?"X":"0"));
					}
					
					//remarks
					if($config[v_remarks]==1){
		            	$amn_text .=  sprintf("\t\t%s:\t%s\n", REG_REG_19,$teilnehmer[reg_remarks]);
					}
		            
		            //Datum & IP immer!!
		            $amn_text .=  sprintf("\t\t%s:\t%s\n", REG_REG_50,$teilnehmer[reg_date]);
		            $amn_text .=  sprintf("\t\t%s:\t\t%s\n", REG_REG_37,$teilnehmer[reg_ip]);
		           
					$this->debug("Turnier Registrierung> {$text}");
		            return $amn_text;
		             
	}
	
	/**
	* @info assembling all Tournament data for confirmation mail
	* @parameter known array of tournament data assembled by Class cTournament
	* @return string 
	* @access privat
	*/
	protected function getTournamentText(){
		
		$turnier = cTournament::getInstance()->getTournamentData();
		$text  = sprintf("%s - %s\n\n", $turnier[reg_tournament], REG_REG_89);  
		
		if(strlen($turnier[reg_adress])>0 && strlen($turnier[reg_plz])>0 && strlen($turnier[reg_city])>0){
			$text .= sprintf("%s:%s, %s %s\n", REG_REG_90, $turnier[reg_adress],  $turnier[reg_plz], $turnier[reg_city]);
		}
			
		$text .= sprintf("%s:%s\n", REG_REG_91, $turnier[reg_target]);
		
		if(strlen($this->config[reg_url])>0){
			$text .= sprintf("%s %s\n\n\n", REG_REG_92,$this->config[reg_url]);
		}	
		
		$this->debug("Turnier Info> {$text}");
		
		return $text;
	}	
	
	/**
	* @info final Greetings for confirmation mail
	* 
	* @return string 
	* @access privat
	*/
	protected function getFinalGreetings(){
		
		
		$text   = sprintf("\n\n%s\n", REG_REG_93);  
		$text  .= sprintf("\n%s\n", REG_REG_94);
		$text  .= sprintf("%s\n", REG_REG_95);
			
		$this->debug("Turnier Greetings> {$text}");
		return $text;
	}	
	
	/**
	* @info send mail method ; if you want to put some mor information into the
	* confirmation mail edit this method
	* @parameter known array of parcipitaion data assembled by Class cRegister
	* @return bool
	* @access public
	*/
	public function sendMail($teilnehmer){
		
		try {
			
		
			//no mail confirmation requested
			if($this->config[reg_mail]!=1)return ;
			
			//Turnierdaten!!!
			$mail_text=$this->getTournamentText();
			
			//including registration data
			if($this->config[reg_data]==1)
				$mail_text.=$this->getRegisterText($teilnehmer);
			
			$mail_text.=$this->getFinalGreetings();
			
			
			
			$name= trim(sprintf("%s %s, %s",$teilnehmer[reg_titel], $teilnehmer[reg_name], $teilnehmer[reg_vorname]));
			$result = sendemail($teilnehmer['reg_email'], $this->config[reg_subject], $mail_text, 
								"{$name}", $this->config[reg_abs], $this->config[reg_name], "", $this->config[reg_cc], $this->config[reg_bcc]);
			
			
			if(!$result)
				throw new Exception("Send Mail Error");
			
			$this->debug("send mail successful");	         		
			return $result;
			
			}
		catch(Exception $e){
			$this->exception_handler($e);
			$message=sprintf("%s: %s<p>%s!</p>",REG_REG_99, $e->getMessage(),REG_REG_100);
			print($message);
			return false;
		}		

	}	
		
	
	
	
}

?>
