<?php
/*
 ----------------------------------------------------------------------------+
|     e107 website system plugIn
|     http://e107.org
|     jalist@e107.org
|
|     Released under the terms and conditions of the
|     GNU General Public License (http://gnu.org).
|
|     $Source: /cvsroot/e107/e107_0.7/e107_plugins/registration/cRegistration.php $
|     $Revision: 1.0 $
|	  $Created on 11.02.2009
|     $Date: 2009/02/11 $
|     $Author: mumm $
+----------------------------------------------------------------------------+
*/
@require_once ("cTournament.php");
@require_once ("cConfig.php");
@require_once ("cMail.php");

class cRegistration {
	

	
	private static $instance;
	protected $teilnehmer;
	protected $table="teilnehmer";
	protected $pre="reg_";//all variables need to have this pre
	protected $error="";
	protected $debug=false; //toggles debug mode of this class
	protected $verband = array( '--'  => 'kein Mitglied',
	                          'AUS' => 'ausl&auml;ndischer Verband',
	                          'BW'  => 'Baden-W&uuml;rttemberg',
							  'BAY' => 'Bayern',
							  'BER' => 'Berlin',
							  'BST' => 'Brandenburg/Sachsen/Th&uuml;ringen',
							  'HB'  => 'Bremen',
							  'HH'  => 'Hamburg',
							  'HES' => 'Hessen',
							  'MVP' => 'Mecklenburg-Vorpommern',
							  'NS'  => 'Niedersachsen/Sachsen-Anhalt',
							  'NRW' => 'Nordrhein-Westfalen',
							  'RPF' => 'Rheinland-Pfalz',
							  'SAR' => 'Saarland',
							  'SH'  => 'Schleswig-Holstein');
	protected $country = array(	 'DE' => 'DEUTSCHLAND',
			                     'AT' => 'AUSTRIA',
			                     'BY' => 'BELARUS',
			                     'BE' => 'BELGIUM',
			                     'BA' => 'BOSNIA HERCEGOVINA',
			                     'BG' => 'BULGARIA',
			                     'CN' => 'CHINA',
			                     'HR' => 'CROATIA',
			                     'CY' => 'CYPRUS',
			                     'CZ' => 'CZECH REPUBLIC',
			                     'DK' => 'DENMARK',
			                     'EE' => 'ESTONIA',
			                     'FI' => 'FINLAND',
			                     'FR' => 'FRANCE',
			                     'GR' => 'GREECE',
			                     'HU' => 'HUNGARY',
			                     'IS' => 'ICELAND',
			                     'IE' => 'IRELAND',
			                     'IT' => 'ITALY',
			                     'JP' => 'JAPAN',
			                     'KR' => 'KOREA, REPUBLIC OF',
								 'KO' => 'KOSOVO',
			                     'LV' => 'LATVIA',
			                     'LI' => 'LIECHTENSTEIN',
			                     'LT' => 'LITHUANIA',
			                     'LU' => 'LUXEMBOURG',
			                     'MT' => 'MALTA',
			                     'MD' => 'MOLDOVA, REPUBLIC OF',
			                     'NL' => 'NETHERLANDS',
			                     'NO' => 'NORWAY',
			                     'PL' => 'POLAND',
			                     'PT' => 'PORTUGAL',
			                     'RO' => 'ROMANIA',
			                     'RU' => 'RUSSIAN FEDERATION',
								 'SE' => 'SERBIA',
			                     'SK' => 'SLOVAKIA',
			                     'SI' => 'SLOVENIA',
			                     'ES' => 'SPAIN',
			                     'CH' => 'SWITZERLAND',
			                     'TR' => 'TURKEY',
			                     'UA' => 'UKRAINE',
			                     'GB' => 'UNITED KINGDOM',
			                     'US' => 'UNITED STATES',
			                     'OT' => 'OTHER');
			                     
			                     
	/**
	 * constructor is private
	 * use getInstance() to get a singleton class object
	 */
	protected function __construct(){
		
		$this->debug("Construct");
		
	}
	
	/**
	 * clone is private -> singleton
	 * 
	 */
	private function __clone(){	}
	
	public function __destruct(){ }
	
				
	public function __get($property){
		$this->errorLog("Die Eigenschaft {$property} soll ausgelesen werden.\n");
	}
	
	public function __set($property, $value){
		$this->errorLog("Die Eigenschaft {$property} soll gesetzt werden.\n");
	}
	
	/**
	* @info class internal global exception handler 
	* @parameter: exception
	* @access private
	*/
	protected function exception_handler($exception) {
	  
	  $message  = sprintf("Nicht aufgefangene Exception: %s\n", $exception->getMessage());
	  $message .= sprintf("\t\tErrorCode: %s\n", $exception->getCode());
	  $message .= sprintf("\t\tDatei: %s\n", $exception->getFile());
	  $message .= sprintf("\t\tZeile: %s\n", $exception->getLine());
	  $message .= sprintf("\t\tTrace: %s\n\n", $exception->getTraceAsString());
	  $this->errorLog($message);
	}

	
	/**
	* @info debug method for listing content of arrays 
	* @parameter: array
	* @access private
	*/
	protected function debugArray($arr){
	
		//debug
		$content=sprintf("Array size %s, Content...\n",sizeof($arr));
		foreach($arr as $k => $v){
				$content.=sprintf("\t\t[%s]=%s\n", $k, $v);
		}
		$this->debug(sprintf("%s", $content));	
		
	}
	
	/**
	* @info debug method for listing all procedure calls 
	* @parameter: class var debug=true for detailed debug mode
	* @access private
	*/
	protected function debug($message){
	
		if(!$this->debug)return;
		$this->errorLog($message);
		
	}
	
	/**
	* @info errorLog method for listing all errors and exceptions 
	* @access private
	*/
	protected function errorLog($message){
	
		$message = sprintf("%s: %s", get_class($this),$message);
		cDebugger::getInstance()->debug($message);
		
	}
	
	
	//singleton
	public static function getInstance(){
		
		if(self::$instance == null) self::$instance= new cRegistration();
		return self::$instance;
	}
	
		
	/**
	* @info shows the online register formular  
	* @access public
	*/	
	public function showRegisterForm() {
		
		$text="";
		$turnier=cTournament::getInstance();
		$this->debug("Methode showRegisterForm()");
		
		//if tournament is open for register
		if($turnier->isOpen()){
			
			$text  =	sprintf("<form style='padding:0;margin:0;border:0;display:inline;' id='registerform' action='%s' method='post' enctype='multipart/form-data' onsubmit=''>", e_SELF);
			$text .=	sprintf("<table style='width:95%%;text-align:left;padding:0;margin:0.5em;background:none; border:0;'>");
			$text .=	$this->getInputPreferences();	
			
			$text .= "<tr><td></td><td style='text-align:left'>";
			$text .= sprintf("<input class='button' style='width:%s;margin-top:2em;' type='submit'  value='%s' id='%s' name='%s' />","10em", REG_REG_1,"new","new");
			$text .= "</td></tr>";	
			$text .= "</table></form>";
			
			//error text if invalid input
			$text .= $this->getErrorMessage();
		}
		else if($turnier->isFinished()){
			$text =	sprintf("<p>%s</p>",REG_REG_57);
		}
		else {//anmeldefrist abgelaufen
			$text =	sprintf("<p>%s</p>",REG_REG_58);
		}
		
		return trim($text);	
		
	}
	
	/**
	* @info assembles the formular input 
	* this is open to public
	* @access private
	*/	
	protected function getInputPreferences() {
		
		$text="";
		$style1="width:2em; white-space:nowrap;padding:5px;vertical-align:top;";//erste spalte
		$style2="width:2em; white-space:nowrap;padding:5px;vertical-align:top;";//zweite spalte
		$config = cConfig::getInstance()->getConfiguration();
		$mandatory=sprintf("<sup>*</sup>");
		
		//anrede & titel
		if(($config[v_sex]==1 && $config[v_titel]==1)){
			$text .= sprintf("<tr>
								<td style='%s;vertical-align:middle;'>%s:</td>
								<td style='%s;margin:0;padding:0;'>
									<table style='margin=0;padding:0;border:0'><tr>
										<td style='vertical-align:top;width:12em;padding-right:4em;'>
											<select name='reg_sex' size='1' style='text-align:center;'>
												<option value='m' %s>%s</option>
												<option value='f' %s>%s</option>
											</select>
										</td>
										<td style='vertical-align:top;'>
											<label style='vertical-align:top;padding-right:1em;'>%s<sup>*</sup>:</label><input style='width:10em;display:inline;' name='reg_titel' type='text' size='20' maxlength='30' value='%s'>
										</td>
									</tr></table>		
									
								</td>
							</tr>",$style1,REG_REG_5,$style2,(isset($this->teilnehmer[reg_sex]) && strtolower($this->teilnehmer[reg_sex])=='m')?"selected='selected'":"",REG_REG_8, 
							(isset($this->teilnehmer[reg_sex]) && strtolower($this->teilnehmer[reg_sex])=='f')?"selected='selected'":"",REG_REG_9, REG_REG_6, $this->teilnehmer[reg_titel]);
		}
		else if($config[v_sex]==1){
			$text .= sprintf("<tr>
								<td style='%s'>%s:</td>
								<td style='%s;margin:0;'>
											<select name='reg_sex' size='1' style='text-align:center;'>
												<option value='m' %s>%s</option>
												<option value='f' %s>%s</option>
											</select>
								</td>
							</tr>",$style1,REG_REG_5,$style2,(isset($this->teilnehmer[reg_sex]) && strtolower($this->teilnehmer[reg_sex])=='m')?"selected='selected'":"",REG_REG_8, 
							(isset($this->teilnehmer[reg_sex]) && strtolower($this->teilnehmer[reg_sex])=='f')?"selected='selected'":"",REG_REG_9);
		}	
		else if($config[v_titel]==1){
			$text .= sprintf("<tr>
								<td style='%s'>%s:</td>
								<td style='%s;margin:0;'>
											<input style='width:10em;display:inline;' name='reg_titel' type='text' size='20' maxlength='30' value='%s'>
								</td>
							</tr>",$style1,REG_REG_6,$style2, $this->teilnehmer[reg_titel]);
		}							
						
		
		//vorname
		$text .= sprintf("<tr>
							<td style='%s'>%s<sup>*</sup>:</td>
							<td style='%s'>
								<input name='reg_vorname' type='text' size='30' style='width:20em;' maxlength='60' value='%s'>
							</td>
						</tr>",$style1,REG_REG_3,$style2,$this->teilnehmer[reg_vorname]);	
		
		
		
		//name
		$text .= sprintf("<tr>
							<td style='%s'>%s<sup>*</sup>:</td>
							<td style='width:%s;'>
								<input name='reg_name' type='text' size='30' style='width:20em;' maxlength='60' value='%s'>
							</td>
						</tr>",$style1,REG_REG_4,$style2,$this->teilnehmer[reg_name]);
		
		
		//level
		if($config[v_level]==1){
			$option="";
			
			for($i=1; $i<=7;$i++){
				$option.=sprintf("<option value='%s' %s>%s</option>", $i, (isset($this->teilnehmer[reg_level]) && abs($this->teilnehmer[reg_level])==$i)?"selected='selected'":"",$i);
			}	
			$text .= sprintf("<tr>
								<td style='%s; vertical-align:middle;'>%s%s:</td>
								<td style='%s;width:90%%'>
									<select name='level' size='1' style='width:3em;text-align:center;'>
									%s
									</select>
									<select style='margin-left:10px;width:5em;text-align:center;' name='rank' size='1'>
										<option value='d' %s>%s</option>
										<option value='k' %s>%s</option>
									</select>
								</td>
							  </tr>",$style1,REG_REG_7, ($config[m_level]==1)?$mandatory:"", $style2,$option, (isset($this->teilnehmer[reg_level]) && ($this->teilnehmer[reg_level])>0)?"selected='selected'":"", REG_REG_10, 
							  (isset($this->teilnehmer[reg_level]) && ($this->teilnehmer[reg_level])<0)?"selected='selected'":"",REG_REG_11);
			
		}
		//verband
		if($config[v_verband]==1 ){
				$ass_option="";
				foreach($this->verband as $k => $v) {
					$ass_option.=sprintf("<option value='%s' %s>%s</option>", $k, (isset($this->teilnehmer[reg_sex]) && $this->teilnehmer[reg_verband]==$k)?"selected='selected'":"",$v);
				}	
				$text .= sprintf("<tr>
									<td style='%s;'>%s%s:</td>
									<td style='%s;width:90%%;'>
										<label style='display:block;'>%s</label>
										<select name='reg_verband' size='1'>
										%s
										</select>
										
									</td>
								  </tr>",$style1,REG_REG_29, ($config[m_verband]==1)?$mandatory:"",$style2, REG_REG_30, $ass_option);
		}						  
		
		
	
		
		$text .= sprintf("<tr>
							<td style='%s;'></td>
							<td style='%s;'>
								<table style='margin=0;padding:0;border:0'><tr>", $style1,$style2);
		
		//hauptturnier & sidevent
		if($config[v_sideevent]==1 ){						
			$text .= sprintf("			<td style='vertical-align:top;width:12em;padding-right:3em;'>
											<ul style='list-style-type:none; margin:0;'>
												<li><input style='vertical-align:middle' type='checkbox' id='reg_mainevent' name='reg_mainevent' value='1' %s><label style='vertical-align:middle;' for='reg_mainevent'>%s</label></li>
												<li><input style='vertical-align:middle' type='checkbox' id='reg_sideevent' name='reg_sideevent' value='1' %s><label style='vertical-align:middle;' for='reg_sideevent'>%s</label></li>
											</ul>
										</td>",
										(!isset($this->teilnehmer) || $this->teilnehmer[reg_mainevent]==1)? "checked='checked'":"",REG_REG_21,
							  			(isset($this->teilnehmer) &&  $this->teilnehmer[reg_sideevent]==1)? "checked='checked'":"",REG_REG_22 	);
		}		
		else{						
				$text .= sprintf("			<td><input type='hidden' name='reg_mainevent' value='1'></td>");}
										
		
		//teilnehmer, helfer, gast	
		if($config[v_gast]==1 || $config[v_helfer]==1  ){						
			$text .= sprintf("			<td style='vertical-align:top;width:12em;padding-right:3em;'>
											<ul style='list-style-type:none;margin:0'>
												<li><input style='vertical-align:middle' type='radio' name='reg_teilnahme' id='part1' value='1' %s><label for='part1' style='vertical-align:middle;'>%s</label></li>",
												(!isset($this->teilnehmer) || $this->teilnehmer[reg_teilnahme]==1)? "checked='checked'":"",REG_REG_26);
			if($config[v_helfer]==1){								
									$text .= sprintf("<li><input style='vertical-align:middle' type='radio' name='reg_teilnahme' id='part2' value='2' %s><label for='part2' style='vertical-align:middle;'>%s</label></li>",
												(isset($this->teilnehmer) && $this->teilnehmer[reg_teilnahme]==2)? "checked='checked'":"",REG_REG_27);
			}				
			
			if($config[v_gast]==1){
				$text .= sprintf("<li><input style='vertical-align:middle' type='radio' name='reg_teilnahme' id='part3' value='3' %s><label for='part3' style='vertical-align:middle;'>%s</label></li>",
									(isset($this->teilnehmer) && $this->teilnehmer[reg_teilnahme]==3)? "checked='checked'":"",REG_REG_28);
			}									
											
			$text .= sprintf("</ul></td>");
		}
		else {
			$text .= sprintf("<td><input type='hidden' name='reg_teilnahme' value='1'></td>");
		}								

		//ermaessigung
		if($config[v_discount]==1 ){
			$text .= sprintf("			<td style='vertical-align:top;width:12em;padding-right:3em;'>
											<ul style='list-style-type:none;margin:0;'>
												<li><input style='vertical-align:middle' type='checkbox' name='reg_discount' id='reg_discount' value='1' %s><label for='reg_discount' style='vertical-align:middle'>%s</label></li>
											</ul>
											<ul style='list-style-type:none; margin:0;'>
												<li><input style='vertical-align:middle' type='radio' name='reg_discounttype' id='disc1'  value='1' %s><label style='vertical-align:middle' for='disc1'>%s</label></li>
												<li><input style='vertical-align:middle' type='radio' name='reg_discounttype' id='disc2'  value='2' %s><label style='vertical-align:middle' for='disc2'>%s</label></li>
											</ul>
										</td>",
									
										(isset($this->teilnehmer) && $this->teilnehmer[reg_discount]==1)? "checked='checked'":"",REG_REG_25,
									  (isset($this->teilnehmer) && $this->teilnehmer[reg_discounttype]==1)? "checked='checked'":"",REG_REG_23,
									  (isset($this->teilnehmer) && $this->teilnehmer[reg_discounttype]==2)? "checked='checked'":"",REG_REG_24);
		}
		
		//unterkunft
		if($config[v_accomodation]==1){							  
			$text .= sprintf("			<td style='vertical-align:top;width:12em;padding-right:3em;'>
											<ul style='list-style-type:none;margin:0;'>
												<li><input style='vertical-align:middle' type='checkbox' name='reg_accomodation' id='reg_accomodation' value='1' %s><label for='reg_accomodation' style='vertical-align:middle'>%s</label></li>
											</ul>
										</td>",(isset($this->teilnehmer) && $this->teilnehmer[reg_accomodation]==1)? "checked='checked'":"",REG_REG_20);
		}								
		$text .= sprintf("			</tr></table>
									</td>
								  </tr>");
						  			
		
		
		//ort & plz
		if($config[v_plz]==1 ){
			$text .= sprintf("<tr>
								<td style='%s; vertical-align:middle;'>%s%s:</td>
								<td style='%s;padding-top:0;margin:0;padding:0;'>
									<table style='margin=0;padding:0;border:0'><tr>
										<td style='vertical-align:top;width:12em;padding-right:4em;'>
											<input style='width:6em;' name='reg_plz' type='text' size='5' maxlength='30' value='%s'>
										</td>
										<td style='vertical-align:top;'>
											<label style='vertical-align:top;padding-right:1em;'>%s<sup>*</sup>:</label><input style='width:17em;' name='reg_city' type='text' size='20' maxlength='30' value='%s'>
										</td>
									</tr></table>			
								</td>
								
							  </tr>",$style1,REG_REG_13,($config[m_plz]==1)?$mandatory:"",$style2, $this->teilnehmer[reg_plz],REG_REG_14,$this->teilnehmer[reg_city]);
		}
		else{	
			
			$text .= sprintf("<tr>
								<td style='%s'>%s<sup>*</sup>:</td>
								<td style='%s;padding-top:0;margin:0;'>
									<input style='width:20em;display:inline;' name='reg_city' type='text' size='20' maxlength='30' value='%s'>
								</td>
								
							  </tr>",$style1,REG_REG_14,$style2, $this->teilnehmer[reg_city]);			  
		}
		
		//adresse
		if($config[v_adress]==1){
			$text .= sprintf("<tr>
								<td style='%s;vertical-align:middle;'>%s%s:</td>
								<td style='%s;'>
									<input name='reg_adress' type='text' size='30' style='width:30em;' maxlength='60' value='%s'>
								</td>
							  </tr>",$style1,REG_REG_15,($config[m_adress]==1)?$mandatory:"",$style2,$this->teilnehmer[reg_adress]);	
		}																					
		//land
		if($config[v_country]==1){
			$ctr_option="";
			foreach($this->country as $k => $v){ 
				$ctr_option.=sprintf("<option value='%s' %s>%s</option>",$k,(isset($this->teilnehmer[reg_country]) && $this->teilnehmer[reg_country]==$k)?"selected='selected'":"",$v);
			}	
			$text .= sprintf("<tr>
								<td style='%s'>%s%s:</td>
								<td style='%s;'>
									<select name='reg_country' size='1'>
									%s
									</select>
									
								</td>
							  </tr>",$style1,REG_REG_12, ($config[m_country]==1)?$mandatory:"",$style2, $ctr_option);
		}															
		//email
		$text .= sprintf("<tr>
							<td style='%s'>%s<sup>*</sup>:</td>
							<td style='%s;'>
								<input name='reg_email' type='text' size='30' style='width:30em' maxlength='80' value='%s'>
							</td>
						  </tr>",$style1,REG_REG_16,$style2,$this->teilnehmer[reg_email]);	
		
		//telefon1
		if($config[v_phone1]==1 ){
			$text .= sprintf("<tr>
								<td style='%s;vertical-align:middle;'>%s%s:</td>
								<td style='%s;'>
									<input name='reg_phone1' type='text' size='30' style='width:20em' maxlength='60' value='%s'>
								</td>
							  </tr>",$style1,REG_REG_17,($config[m_phone1]==1)?$mandatory:"",$style2,$this->teilnehmer[reg_phone1]);	
		}
		//telefon2
		if($config[v_phone2]==1 ){
			$text .= sprintf("<tr>
								<td style='%s;vertical-align:middle;'>%s:</td>
								<td style='%s;'>
									<input name='reg_phone2' type='text' size='30' style='width:20em' maxlength='60' value='%s'>
								</td>
							  </tr>",$style1,REG_REG_18,$style2,$this->teilnehmer[reg_phone2]);
		}
		//bemerkung
		if($config[v_remarks]==1){
			$text .= sprintf("<tr>
								<td style='%s;'>%s:</td>
								<td style='width:%s;'>
									<textarea name='reg_remarks' cols='20' rows='3' style='width:30em;'>%s</textarea>
	 							</td>
							  </tr>",$style1,REG_REG_19,$style2,$this->teilnehmer[reg_remarks]);
		}																																																
		return $text;
		
	
	}
	
	/**
	* @info proof input data if mandatories are fulfilled as well as the integrity of given email 
	* @access private
	*/	
	protected function validateInput(){
		
		$config = cConfig::getInstance()->getConfiguration();
		$msg=array();
		//name  
		if(strlen(trim($this->teilnehmer[reg_name]))==0)
			$msg[]=sprintf("%s", REG_REG_4);
		
		//vorname
		if(strlen(trim($this->teilnehmer[reg_vorname]))==0)
			$msg[]=sprintf("%s",REG_REG_3);
		
		//reg_city
		if(strlen(trim($this->teilnehmer[reg_city]))==0)
			$msg[]=sprintf("%s",REG_REG_14);
		
		//reg_email
		if(strlen(trim($this->teilnehmer[reg_email]))==0 || !$this->isEmailValid(trim($this->teilnehmer[reg_email])))
			$msg[]=sprintf("%s",REG_REG_16);
		
		//mandatories	
		//plz
		if($config[v_plz]==1 && $config[m_plz]==1 && strlen(trim($this->teilnehmer[reg_plz]))==0)
			$msg[]=sprintf("%s",REG_REG_13);
		
		//adress
		if($config[v_adress]==1 &&  $config[m_adress]==1 && strlen(trim($this->teilnehmer[reg_adress]))==0)
			$msg[]=sprintf("%s",REG_REG_15);
			
		//telefon
		if($config[v_phone1]==1 &&  $config[m_phone1]==1 && strlen(trim($this->teilnehmer[reg_phone1]))==0)
			$msg[]=sprintf("%s",REG_REG_17);		
		
		$this->error=implode(", ",$msg);
		
		$res=strlen($this->error)==0;
		$this->debug(sprintf("Validating %s",$res?"TRUE":"FALSE"));		
		
		return $res;	
	}
	
	/**
	* @info proof if given email format is correct 
	* @access private
	*/	
	protected function isEmailValid($email){
		
		$mailpattern = "#^[-!\#$%&\"*+\\./\d=?A-Z^_|'a-z{|}~]+" .
			"@".
			"[-!\#$%&\"*+\\./\d=?A-Z^_|'a-z{|}~]+\." .
			"[-!\#$%&\"*+\\./\d=?A-Z^_|'a-z{|}~]+$#";
				
		return preg_match($mailpattern,$email);
	
	}
	
	/**
	* @info get formatted data of a single registered user 
	* @access private
	*/	
	protected function getUserData($id){
		
		try{
			
			global $sql;
			
			$data=array();
			$result=$sql->db_Select("teilnehmer", "*" , "WHERE reg_id=$id", "");
			if(!$result) {
				$error=sprintf("DB Error %s: %s", mysql_errno(), mysql_error());
				if(mysql_errno()>0) throw new Exception ($error);
				$this->debug("Kein Datenbankeintrag gefunden");	
			}	
			
				//$teilnehmer=array();
				if($row = $sql->db_Fetch())	{	
						
						foreach($row as $k => $v){
							$data[$k]=$v;
						}
						//debug
						$this->debug(sprintf("DB result %s",$data));
						$this->debugArray($data);
				}	
			
			
			return $data;
		
		}
		catch(Exception $e){
			$this->exception_handler($e);
			$message=sprintf("%s: %s<p>%s!</p>",REG_REG_99, $e->getMessage(),REG_REG_100);
			exit($message);
		}		
	}
	
	/**
	* @info get all registered User by request order
	* @return array of formatted user list 
	* @access private
	*/	
	protected function getAllParcipitants($order){
		
		try {
			
		
			global $tp, $sql;
			
			//reihenfolge wird immer durch Name, Vornamen ergnzt
			if(empty($order))$order="reg_name, reg_vorname";
			else 	$order.=', reg_name, reg_vorname';
			$data=array();
			
			$this->debug("DB select {$this->table}");
			$tid=cTournament::getInstance()->getActualTournamentId();
			
			$result=$sql->db_Select("teilnehmer", "*" , "WHERE reg_tournamentId=$tid ORDER BY $order ", "");
			
			if(!$result) {
					$error=sprintf("DB Error %s: %s", mysql_errno(), mysql_error());
					if(mysql_errno()>0) throw new Exception ($error);
					$this->debug("Kein Datenbankeintrag gefunden");	
				}	
				
			
			//$teilnehmer=array();
			while($row = $sql->db_Fetch())	{	
					
					$teilnehmer=array();
					//reihenfolge entspricht der spaltenfolge in der tabellendarstellung
					
					//id				
					($res=$row[reg_id])?	$teilnehmer[ID] = $res : $teilnehmer[ID] ="";
					//tid				
					($res=$row[reg_tournamentId])?	$teilnehmer[TID] = $res : $teilnehmer[TID] ="";
					
					//anrede								
					if(($res=$row[reg_sex])){
						
						if(strtolower($res)=='f')	$teilnehmer[Anrede] = REG_REG_9;
						else 						$teilnehmer[Anrede] = REG_REG_8;
					}
					else $teilnehmer[Anrede]="";
					
					//title						
					($res=$row[reg_titel])?	$teilnehmer[Titel] = $res : $teilnehmer[Titel] ="";
					
					//name						
					($res=$row[reg_name])?	$teilnehmer[Nachname] = $res : $teilnehmer[Nachname] ="";		 		 
					
					//vorname
					($res=$row[reg_vorname])? $teilnehmer[Vorname] = $res : $teilnehmer[Vorname] = "";		
					
					//plz							
					($res=$row[reg_plz])? 	$teilnehmer[PLZ] = $res: $teilnehmer[PLZ] = "";		
					
					//ort							
					($res=$row[reg_city])? 	$teilnehmer[Ort] = $res: $teilnehmer[Ort] = "";	
					
					//land							
					($res=$row[reg_country])?$teilnehmer[Land]= $res:$teilnehmer[Land]="";	
							
					//adresse							
					($res=$row[reg_adress])?$teilnehmer[Adresse]= $res:$teilnehmer[Adresse]="";		
					
					//tel							
					($res=$row[reg_phone1])?$teilnehmer[Telefon]= $res:$teilnehmer[Telefon]="";	
					
					//mobile							
					($res=$row[reg_phone2])?$teilnehmer[Handy]= $res:$teilnehmer[Handy]="";	
					
					//email							
					($res=$row[reg_email])?$teilnehmer[email]= $res:$teilnehmer[email]="";	
					
					//level							
					if($res=$row[reg_level]){
						if($res>0) $teilnehmer[Level]= $res ."D";
						else $teilnehmer[Level]=abs($res).'k';
					} 
					else $teilnehmer[Level]="";
					
					//verband							
					($res=$row[reg_verband])?$teilnehmer[Verband]= $res:$teilnehmer[Verband]="";	
					
					//main							
					($res=$row[reg_mainevent])?$teilnehmer[Main]= "x":$teilnehmer[Main]="";
					
					//side							
					($res=$row[reg_sideevent])?$teilnehmer[Side]= "x":$teilnehmer[Side]="";
					
					//teilnahme		
					$teilnehmer[Teilnehmer]=""; $teilnehmer[Helfer]=""; $teilnehmer[Zuschauer]="";					
					
					if($res=$row[reg_teilnahme]){
						
						switch($res) {
							case 1:  $teilnehmer[Teilnehmer]="x";break;
							case 2:  $teilnehmer[Helfer]="x";break;
							case 3:  $teilnehmer[Gast]="x";break;
						}					
						
					}
					
					//discount							
					($res=$row[reg_teilnahme])? $teilnehmer[Rabatt]="x":$teilnehmer[Rabatt]="";
						
					//discount							
					($res=$row[reg_discount])? $teilnehmer[Rabatt]="x":$teilnehmer[Rabatt]="";
					
					//schueler  student							
					$teilnehmer[Schueler]="";$teilnehmer[Student]="";
					if($res=$row[reg_discounttype]){
						
						switch($res) {
							case 1:  $teilnehmer[Schueler]="x";break;
							case 2:  $teilnehmer[Student]="x";break;
							
						}	
					} 
					
					//accomodation							
					($res=$row[reg_accomodation])? $teilnehmer[Accomodation]="x":$teilnehmer[Accomodation]="";
					
					//remarks							
					($res=$row[reg_remarks])? $teilnehmer[Bemerkung]=$res:$teilnehmer[Bemerkung]="";
					
					//registered							
					($res=$row[reg_date])? $teilnehmer[registered]=$res:$teilnehmer[registered]="";
					
					//ip							
					($res=$row[reg_ip])? $teilnehmer[IP]=$res:$teilnehmer[IP]="";				
					
					//updater							
					($res=$row[reg_updater])? $teilnehmer[updateBy]=$res:$teilnehmer[updateBy]="";
					
					//updateip							
					($res=$row[reg_updateip])? $teilnehmer[updateIP]=$res:$teilnehmer[updateIP]="";	
					
					//update
					$teilnehmer[update]="";							
					if(($res=$row[reg_update])){ 
						if($res!='0000-00-00 00:00:00') $teilnehmer[update]=$res;	
					}		
					
					$data[]=$teilnehmer;
					//debug
					$this->debug(sprintf("DB result %s",$teilnehmer));
					$this->debugArray($teilnehmer);
					
			}	
		
			return $data;
		}
		catch(Exception $e){
			$this->exception_handler($e);
			$message=sprintf("%s: %s<p>%s!</p>",REG_REG_99, $e->getMessage(),REG_REG_100);
			exit($message);
		}
	}
	
	/**
	* @info open table of all registered user
	* @access public
	*/	
	public function showRegisteredUser($order=""){
		
		$config = cConfig::getInstance()->getConfiguration();
		$data=$this->getAllParcipitants($order);
		
		
		$border=sprintf("border:0;border-bottom: #444 1px solid;");
		$padding1=sprintf("padding-right: 1em");
		$table.=sprintf("<table align=left style='width:95%%;margin-left:10px;border-collapse:collapse;%s; background:none;'>",$border);
		
		
		$table.=sprintf("<tr>");
		$table.=sprintf("<th style='%s;%s;width:1em;white-space:nowrap;text-align:right;'>%s</th>",$border, $padding1, REG_REG_31);
		$table.=sprintf("<th style='%s;%s;text-align:left;padding-left:1em;'><a href='%s' title='%s'>%s</a></th>",$border,$padding1,e_SELF, REG_REG_33, REG_REG_34);
		if($config[v_level]==1){
			$table.=sprintf("<th style='%s;%s'><a href='%s?order=reg_level' title='%s'>%s</a></th>",$border,$padding1,e_SELF, REG_REG_33, REG_REG_35);
		}
		
		if($config[v_country]==1){	
			$table.=sprintf("<th style='%s;%s'><a href='%s?order=reg_country' title='%s'>%s</a></th>",$border,$padding1,e_SELF, REG_REG_33, REG_REG_12);
		}
		$table.=sprintf("<th style='%s;%s; text-align:left;padding-left:1em;'><a href='%s?order=reg_city' title='%s'>%s</a></th>",$border,$padding1,e_SELF, REG_REG_33, REG_REG_14);
	
		if($config[v_helfer]==1 || $config[v_gast]==1){
			$table.=sprintf("<th style='%s;' title='%s'>%s</th>",$border,REG_REG_26 ,REG_REG_60);
		}
		if($config[v_helfer]==1){
			$table.=sprintf("<th style='%s;' title='%s'>%s</th>",$border, REG_REG_27 ,REG_REG_61);
		}
		if($config[v_gast]==1){
			$table.=sprintf("<th style='%s;' title='%s'>%s</th>",$border, REG_REG_28,REG_REG_62);
		}	
		$table.=sprintf("</tr>");
		
		
		$spieler=$helfer=$gast=0;
		for($i=0;$i<sizeof($data);$i++){
			
			$teilnehmer=$data[$i];
			
			if(!empty($teilnehmer[Teilnehmer]))	$spieler++;
			if(!empty($teilnehmer[Helfer]))		$helfer++;
			if(!empty($teilnehmer[Gast]))		$gast++;
			
			
			$table.=sprintf("<tr>");
			$table.=sprintf("<td style='text-align:right;padding-right:1em;'>%s</td>",$i+1);
			$table.=sprintf("<td style='white-space:nowrap;%s;padding-left:1em;'>%s %s, %s</td>",$padding1,$teilnehmer[Titel], $teilnehmer[Nachname], $teilnehmer[Vorname]);
			
			if($config[v_level]==1){
				$table.=sprintf("<td style='text-align:center;%s'>%s</td>",$padding1,$teilnehmer[Level]);
			}
			
			if($config[v_country]==1){
				$table.=sprintf("<td style='text-align:center;%s'>%s</td>",$padding1,$teilnehmer[Land]);
			}	
			$table.=sprintf("<td style='%s;text-align:left;padding-left:1em;'>%s</td>",$padding1,$teilnehmer[Ort]);
			
			if($config[v_helfer]==1 || $config[v_gast]==1){
				$table.=sprintf("<td style='text-align:center;'>%s</td>",$teilnehmer[Teilnehmer]);
			}
			if($config[v_helfer]==1){
				$table.=sprintf("<td style='text-align:center;'>%s</td>",$teilnehmer[Helfer]);
			}
			if($config[v_gast]==1){
				$table.=sprintf("<td style='text-align:center;'>%s</td>",$teilnehmer[Gast]);
			}	
			$table.=sprintf("</tr>");
			
		}	
		
		$table.=sprintf("</table>");
		
		//auflistung teilnehmer, gast, helfer falls konfiguriert
		$details=array();
		$strList="";
		if($config[v_helfer]==1 || $config[v_gast]==1)$details[]=sprintf("%s %s",$spieler, REG_REG_26);
		if($config[v_helfer]==1)$details[]=sprintf("%s %s",$helfer, REG_REG_27);
		if($config[v_gast]==1)$details[]=sprintf("%s %s",$gast, REG_REG_28);
		if(sizeof($details)>0) { 
				$strDet=implode(", ", $details);
				$strList=sprintf("(%s)",$strDet);
					
		}
		
		//info muss hier zusammengesetzt werden
		$info=sprintf("<p style='margin:10px;white-space:nowrap;clear:both;'>
						<span style='font-weight:bold'>%s %s</span>%s
						</p>", sizeof($data), REG_REG_42, $strList);
		
		$table.=sprintf("<p style='clear:both;'></p>");				
		//solange der schwachsinn mit den styles nicht geklrt ist				
		//$table.=$info;
		
		return $table;
		
	}
	
	
	/**
	* @info table of all registered user
	* used as admin view including editing and delete
	* make sure only admin can access this method 
	* @access public
	*/	
	public function showAllParcipitants($order=""){
		
		
		$data=$this->getAllParcipitants($order);
		
		
		$border=sprintf("border-style:ridge; border-width:2px;");
		$table.=sprintf("<table align=left style='margin-left:10px;border-collapse:collapse;%s; background:none;'>",USER_WIDTH, $border);
		
		$spieler=$helfer=$gast=0;
		for($i=0;$i<sizeof($data);$i++){
			
			$teilnehmer=$data[$i];
			
			if(!empty($teilnehmer[Teilnehmer]))	$spieler++;
			if(!empty($teilnehmer[Helfer]))		$helfer++;
			if(!empty($teilnehmer[Gast]))		$gast++;
			
			
			if($i==0){
				$table.=sprintf("<tr><thead>");
				$table.=sprintf("<th style='%s;text-align:center;'>%s</th>",$border, REG_REG_31);
				$table.=sprintf("<th style='%s;text-align:center;'>%s</th>",$border, REG_REG_32);
				$table.=sprintf("<th style='%s;text-align:center;'><a href='%s' title='%s'>%s</a></th>",$border,e_SELF, REG_REG_33, REG_REG_34);
				$table.=sprintf("<th style='%s;text-align:center;'><a href='%s?order=reg_level' title='%s'>%s</a></th>",$border,e_SELF, REG_REG_33, REG_REG_35);
				$table.=sprintf("<th style='%s;text-align:center;'><a href='%s?order=reg_country' title='%s'>%s</a></th>",$border,e_SELF, REG_REG_33, REG_REG_12);
				$table.=sprintf("<th style='%s;text-align:center;'><a href='%s?order=reg_verband' title='%s'>%s</a></th>",$border,e_SELF, REG_REG_33, REG_REG_29);
				$table.=sprintf("<th style='%s;text-align:center;'>%s</th>",$border, REG_REG_15);
				$table.=sprintf("<th style='%s;text-align:center;'>%s</th>",$border, REG_REG_16);
				$table.=sprintf("<th style='%s;text-align:center;'>%s</th>",$border, REG_REG_17);
				$table.=sprintf("<th style='%s;text-align:center;'>%s</th>",$border, REG_REG_18);
				$table.=sprintf("<th style='%s;text-align:center;' title='%s'>%s</th>",$border,REG_REG_21,"M");
				$table.=sprintf("<th style='%s;text-align:center;' title='%s'>%s</th>",$border,REG_REG_22 ,"S");
				$table.=sprintf("<th style='%s;text-align:center;' title='%s'>%s</th>",$border,REG_REG_26 ,REG_REG_60);
				$table.=sprintf("<th style='%s;text-align:center;' title='%s'>%s</th>",$border, REG_REG_27 ,REG_REG_61);
				$table.=sprintf("<th style='%s;text-align:center;' title='%s'>%s</th>",$border, REG_REG_28,REG_REG_62);
				$table.=sprintf("<th style='%s;text-align:center;' title='%s'>%s</th>",$border, REG_REG_25,"R");
				$table.=sprintf("<th style='%s;text-align:center;' title='%s'>%s</th>",$border, REG_REG_23,"U");
				$table.=sprintf("<th style='%s;text-align:center;' title='%s'>%s</th>",$border, REG_REG_24,"E");
				$table.=sprintf("<th style='%s;text-align:center;' title='%s'>%s</th>",$border, REG_REG_20,"A");
				$table.=sprintf("<th style='%s;text-align:center;'>%s</th>",$border, REG_REG_19);
				$table.=sprintf("<th style='%s;text-align:center;'><a href='%s?order=reg_date' title='%s'>%s</a></th>",$border,e_SELF, REG_REG_50, REG_REG_36);
				$table.=sprintf("<th style='%s;text-align:center;'>%s</th>",$border, REG_REG_37);
				$table.=sprintf("<th style='%s;text-align:center;'></th>",$border);
				$table.=sprintf("<thead></tr><tbody>");
			}
			
			$table.=sprintf("<tr>");
			$table.=sprintf("<td style='%s;border-top:0;text-align:right;'>%s</td>",$border,$i+1);
			$table.=sprintf("<td style='%s;border-top:0;text-align:center;'>%s</td>",$border,$teilnehmer[Anrede]);
			$table.=sprintf("<td style='%s;border-top:0;white-space:nowrap;'>%s %s,<br> %s</td>",$border,$teilnehmer[Titel], $teilnehmer[Nachname], $teilnehmer[Vorname]);
			$table.=sprintf("<td style='%s;border-top:0;text-align:center;'>%s</td>",$border,$teilnehmer[Level]);
			$table.=sprintf("<td style='%s;border-top:0;text-align:center;'>%s</td>",$border,$teilnehmer[Land]);
			$table.=sprintf("<td style='%s;border-top:0;text-align:center;'>%s</td>",$border,$teilnehmer[Verband]);
			$table.=sprintf("<td style='%s;border-top:0;white-space:nowrap;'>%s<br>%s %s</td>",$border,$teilnehmer[Adresse], $teilnehmer[PLZ], $teilnehmer[Ort]);
			
			$table.=sprintf("<td style='%s;border-top:0;'>%s</td>",$border,$teilnehmer[email]);
			$table.=sprintf("<td style='%s;border-top:0;'>%s</td>",$border,$teilnehmer[Telefon]);
			$table.=sprintf("<td style='%s;border-top:0;'>%s</td>",$border,$teilnehmer[Handy]);
			$table.=sprintf("<td style='%s;border-top:0;background:yellow;text-align:center;'>%s</td>",$border,$teilnehmer[Main]);
			$table.=sprintf("<td style='%s;border-top:0;background:yellow;text-align:center;'>%s</td>",$border,$teilnehmer[Side]);
			$table.=sprintf("<td style='%s;border-top:0;text-align:center;background:lightblue;'>%s</td>",$border,$teilnehmer[Teilnehmer]);
			$table.=sprintf("<td style='%s;border-top:0;text-align:center;background:lightblue;'>%s</td>",$border,$teilnehmer[Helfer]);
			$table.=sprintf("<td style='%s;border-top:0;text-align:center;background:lightblue;'>%s</td>",$border,$teilnehmer[Gast]);
			$table.=sprintf("<td style='%s;border-top:0;text-align:center;background:lightgreen;'>%s</td>",$border,$teilnehmer[Rabatt]);
			$table.=sprintf("<td style='%s;border-top:0;text-align:center;background:lightgreen;'>%s</td>",$border,$teilnehmer[Schuler]);
			$table.=sprintf("<td style='%s;border-top:0;text-align:center;background:lightgreen;'>%s</td>",$border,$teilnehmer[Student]);
			$table.=sprintf("<td style='%s;border-top:0;text-align:center;background:orange;'>%s</td>",$border,$teilnehmer[Accomodation]);
			$table.=sprintf("<td style='%s;border-top:0;width:20em;white-space:wrap'>%s</td>",$border,$teilnehmer[Bemerkung]);
			$table.=sprintf("<td style='%s;border-top:0;text-align:center;'>%s</td>",$border,$teilnehmer[registered]);
			$table.=sprintf("<td style='%s;border-top:0;text-align:right;'>%s</td>",$border,$teilnehmer[IP]);
			$table.=sprintf("<td style='%s;border-top:0;text-align:right;'>",$border);
			$table.=sprintf("<form style='margin:0;padding:0;display:inline;' action='%s?action=edit&id=%s' method='post'><input style='margin:3px' type='image' src='%sadmin_images/edit_16.png' title='%s'/></form>",e_SELF,$teilnehmer[ID],e_IMAGE,REG_REG_38);
			$table.=sprintf("<form style='margin:0;padding:0;display:inline;' action='%s?action=delete&id=%s' method='post' onSubmit='return confirmDelete()'><input style='margin:3px' type='image' src='%sadmin_images/delete_16.png' title='%s'/></form>",e_SELF,$teilnehmer[ID],e_IMAGE,REG_REG_39);
			$table.=sprintf("</td></tr>");
		}	
		
		$table.=sprintf("</tbody></table>");
		
		//info muss hier zusammengesetzt werden
		$info=sprintf("<p style='margin:10px;'>%s <a style='margin-right:3em;' href='%s?csv=csv'>%s</a> <span style='font-weight:bold'>%s %s</span> (%s %s, %s %s, %s %s)</p>",REG_REG_40,e_SELF,REG_REG_41, sizeof($data), REG_REG_42, $spieler, REG_REG_26, $helfer, REG_REG_27, $gast, REG_REG_28);
		
		return $info.$table;
		
	}
	
	/**
	* @info shows the edit register formular  
	* @access public
	*/	
	public function showEditForm() {
		
		if(empty($this->error))
			$this->teilnehmer = $this->getUserData($_REQUEST['id']);
		
		$text  =	sprintf("<form id='registeredit' action='%s?action=edit&id=%s' method='post' enctype='multipart/form-data' onsubmit=''>", e_SELF, $_REQUEST['id']);
		$text .=	sprintf("<table style='%s;text-align:left;margin:5px; background:none; border:0'>", USER_WIDTH);
		$text .=	$this->getInputPreferences();	
		
		$text .= "<tr><td></td><td style='text-align:left;border:0;' class='forumheader' >";
		$text .= sprintf("<input class='button' style='width:%s;margin-right:2em;' type='submit'  value='%s' id='%s' name='%s' /><input class='button' style='width:%s;' type='submit'  value='%s' id='%s' name='%s' />","10em", REG_REG_49,"show","show","10em",REG_REG_48,"update","update");
		$text .= "</td></tr>";	
		$text .= "</table></form>";
		
		//error text if invalid input
		$text .= $this->getErrorMessage();
		
		return $text;	
		
	}
	
	/**
	* @info returns a ressembled error message after validation 
	* reset the error message  
	* @access private
	*/	
	protected function getErrorMessage(){
		
		$msg="";
		//error text if invalid input
		if(isset($this->error) && strlen($this->error)>0)
			$msg=sprintf("<p style='color:red;'>%s: <span style='font-weight:bold;'>%s</span></p>",REG_REG_51,$this->error);
		
		//reset the error
		$this->error="";
		
		return $msg;	
		
	}
	
	
	
		
	/**
	* @info updating a registered user 
	* make sure only admin can access this method
	* the user id is requested and has to be provided 
	* @access public
	*/	
	public function updateParcipitation() {
		
		try {
				
			global $ns, $sql, $tp;  
			
			while(list($key, $value) = each($_POST)){
				
				foreach($_POST as $k => $v){
					if(strpos($k, $this->pre) === 0){
						$this->teilnehmer[$k] = $tp->toDB($v);
					}
				}
			}
			
			//calculate rank
			if(isset($_REQUEST['level']) && isset($_REQUEST['rank'])){
				
				$this->teilnehmer[reg_level]=$_REQUEST['level'];
				if(strtolower($_REQUEST['rank'])=='k') 
					$this->teilnehmer[reg_level]=$this->teilnehmer[reg_level]*(-1);
					
			}
			
			//update bool
			if(!isset($_REQUEST['reg_mainevent']))$this->teilnehmer[reg_mainevent]=0;
			if(!isset($_REQUEST['reg_sideevent']))$this->teilnehmer[reg_sideevent]=0;
			if(!isset($_REQUEST['reg_discount']))$this->teilnehmer[reg_discount]=0;
			if(!isset($_REQUEST['reg_accomodation']))$this->teilnehmer[reg_accomodation]=0;
			
			//eval association
			if(isset($_REQUEST['reg_verband']) && $_REQUEST['reg_verband']=='--')
				unset($this->teilnehmer[reg_verband]);
				
			$this->teilnehmer[reg_update]=date("Y-m-d H:i:s");
			$this->teilnehmer[reg_updateip]= $_SERVER['REMOTE_ADDR'];
			$this->teilnehmer[reg_updater]= USERNAME;
			
			//VALIDATE
			if(!$this->validateInput()) return;
			
			$update=array();
			foreach($this->teilnehmer as $k => $v)	$update[]=sprintf("%s='%s'",$k,$v);
			$cmd = implode(",",$update);
			$cmd .= sprintf(" WHERE reg_id='%s'",$_REQUEST['id']);
			
			$this->debug("DB update {$this->table}");
			$this->debug("SQL statement... \n\t{$cmd}\n");
			
			$result = $sql->db_Update($this->table, $cmd);
			if(!$result) {
				$error=sprintf("DB Error %s: %s", mysql_errno(), mysql_error());
				if(mysql_errno()>0) throw new Exception ($error);
				$this->debug("Update Eintrag nicht gefunden");				
			}	
			else $this->debug("Update erfolgreich");
			
			return $result;
		
		}
		catch(Exception $e){
			$this->exception_handler($e);
			$message=sprintf("%s: %s<p>%s!</p>",REG_REG_99, $e->getMessage(),REG_REG_100);
			exit($message);
			
		}		
		
		
	}
	
	/**
	* @info deleting a registered user 
	* make sure only admin can access this method
	* the user id is requested and has to be provided 
	* @access public
	*/	
	public function deleteParcipitation() {
		
		try {
			global $ns, $sql, $tp;  
			
			$id = $tp->toDB($_REQUEST['id']);
			
			//debug
			$this->debug("DB delete {$this->table}");
			
			$result=$sql->db_Delete($this->table, "reg_id = '$id'");
			if(!$result)
			{
				$error=sprintf("DB Error %s: %s", mysql_errno(), mysql_error());
				if(mysql_errno()>0) throw new Exception ($error);
			}	
				
			$this->debug("Delete erfolgreich");
			
			return $result;
			
		}
		catch(Exception $e){
			$this->exception_handler($e);
			$message=sprintf("%s: %s<p>%s!</p>",REG_REG_99, $e->getMessage(),REG_REG_100);
			exit($message);
			
		}		
		
	}
	
	/**
	* @info new entry to db using formular input 
	* @variable using private array teilnehmer
	* @access public
	*/	
	public function newParcipitation(){
		
		try {
			
			global $tp, $sql;
			
			if(($tid=cTournament::getInstance()->getActualTournamentId())==null)return;
			
			while(list($key, $value) = each($_POST)){
				
				foreach($_POST as $k => $v){
					if(strpos($k, $this->pre) === 0){
						$this->teilnehmer[$k] = $tp->toDB($v);
					}
				}
			}
					
			//calculate rank
			if(isset($_REQUEST['level']) && isset($_REQUEST['rank'])){
				$this->teilnehmer[reg_level]=$_REQUEST['level'];
				if(strtolower($_REQUEST['rank'])=='k') 
					$this->teilnehmer[reg_level]=$this->teilnehmer[reg_level]*(-1);
			}
			
			//eval association
			if(isset($_REQUEST['reg_verband']) && $_REQUEST['reg_verband']=='--')
				unset($this->teilnehmer[reg_verband]);
			
			$this->teilnehmer[reg_tournamentId]= $tid;			
			$this->teilnehmer[reg_date]=date("Y-m-d H:i:s");
			$this->teilnehmer[reg_ip]= $_SERVER['REMOTE_ADDR'];
			
			//VALIDATE
			if(!$this->validateInput()) return $this->showRegisterForm();
			
			//debug
			$this->debug("DB insert {$this->table}");
			$this->debugArray($this->teilnehmer);
						
			$result = $sql->db_Insert($this->table, $this->teilnehmer);
			if(!$result) {
						$error=sprintf("DB Error %s: %s", mysql_errno(), mysql_error());
						if(mysql_errno()>0) throw new Exception ($error);
			}	
					
			$this->debug("Insert erfolgreich");
			
			//mail
			$result = cMail::getInstance()->sendMail($this->teilnehmer);
			
			
			if(!$result) {
						return sprintf("Mail Error: %s", REG_REG_96);
			}	
					
			$this->debug("eMail Confirmation successful");
			
			return $this->showMessage();
		}
		catch(Exception $e){
			$this->exception_handler($e);
			
			$message=sprintf("%s: %s<p>%s.</p>",REG_REG_98, $e->getMessage(),REG_REG_97);
			exit($message);
			
		}	
			
	}	
	
	
	protected function showMessage($msg=REG_REG_63){
		
		$text  =	sprintf("<form id='regfinal' action='%s' method='post' enctype='multipart/form-data' onsubmit=''>", e_SELF);
		$text .=	sprintf("<p>%s</p>", $msg);
		$text .= sprintf("<input class='button' style='width:%s;margin-right:2em;' type='submit'  value='%s' id='%s' name='%s' />","10em", REG_REG_64,"show","show");
			
		$text .= "</form>";
		
		return $text;
	}
	
	/**
	* @info returns all registered user as cvs file for downloading and importing into excel 
	* @access public
	*/
	public function getCSV() {
		
		try {
		//Nr, Anrede, Titel, Vorname, Name, Level, Land, Verband,PLZ, Ort, Adresse,email, Telefon,Handy,Main Event, Side Event,Teilnehmer,
		//Helfer,Zuschauer,Ermaessigung,Schueler,Student,	Uebernachtung,Bemerkung,angemeldet, IP
		$head=array(REG_REG_31, REG_REG_32, REG_REG_6, REG_REG_3, REG_REG_4, 
					REG_REG_35, REG_REG_12, REG_REG_29, 
					REG_REG_13, REG_REG_14, REG_REG_15, 
					REG_REG_16, REG_REG_17,REG_REG_18,
					REG_REG_21, REG_REG_22,REG_REG_26,
					REG_REG_27,REG_REG_28,
					REG_REG_43,REG_REG_44,REG_REG_24,
					REG_REG_20,REG_REG_19, 
					REG_REG_36, REG_REG_37);
				 				
		$csv =$this->fputCSV($head);				
		
		$data=$this->getAllParcipitants("");	
		for($i=0;$i<sizeof($data);$i++){	
			
			$teilnehmer=$data[$i];
			
			//Achtung: Reihenfolge bachten
			$myArray=array($i+1, $teilnehmer[Anrede],  $teilnehmer[Titel] ,  $teilnehmer[Vorname] ,  $teilnehmer[Nachname] ,  
							$teilnehmer[Level], $teilnehmer[Land] ,$teilnehmer[Verband],
							$teilnehmer[PLZ] ,  $teilnehmer[Ort] , $teilnehmer[Adresse] ,
							$teilnehmer[email] , $teilnehmer[Telefon] , $teilnehmer[Handy] ,
							$teilnehmer[Main],$teilnehmer[Side],$teilnehmer[Teilnehmer],
							$teilnehmer[Helfer],$teilnehmer[Gast],
							$teilnehmer[Rabatt],$teilnehmer[Schuler],$teilnehmer[Student],
							$teilnehmer[Accomodation], $teilnehmer[Bemerkung] ,
							$teilnehmer[registered],$teilnehmer[IP]
							
						);
						
			$csv .=$this->fputCSV($myArray);				
			
		}
				
		if(ob_get_contents()) throw new Exception(REG_REG_45);
		
		if(isset($_SERVER['HTTP_USER_AGENT']) && strpos($_SERVER['HTTP_USER_AGENT'],'MSIE'))
			header('Content-Type: application/force-download');
		else
			header('Content-Type: application/octet-stream');
		if(headers_sent()) throw new Exception(REG_REG_45);
		
		header('Content-Length: '.strlen($csv));
		$filename=REG_REG_46.".csv";
		header("Content-disposition: attachment; filename=$filename");
		echo $csv;	
		
		}
		catch(Exception $e){
			$this->exception_handler($e);
			
			$message=sprintf("%s: %s<p>%s!</p>",REG_REG_99, $e->getMessage(),REG_REG_100);
			exit($message);
		}		
	}
	
	/**
	* @info escaping and quoting of all values provided in a string array
	* @return a string with all data seperated by comma  
	* @access public
	*/
	protected function fputCSV($strArrray) {
       
       	$csv = array();
        
        while (list($key, $val) = each($strArrray)) {
			
			$val = str_replace('"', '""', $val);//escaping quotes
            $csv[]= sprintf("\"%s\"",$val);
        }
        
        return implode(",",$csv)."\n";

	}	
	
	/**
	* @info this JavaScript is loaded into the HEAD 
	* @usage just loading into function headerjs() of the main php
	* @access public
	*/	
	public function loadJS(){
    
    	$js=sprintf("<script type=\"text/javascript\">
    					
    					
			 function confirmDelete(){
			 	
			 		var res = confirm('%s');
					return res;
			  }
							
			</script>",REG_REG_47);
			
		return $js;
	
	}
}

?>
