CREATE TABLE teilnehmer (
	
	`reg_id` 					INT UNSIGNED 			NOT NULL AUTO_INCREMENT ,
	`reg_tournamentId` 			INT UNSIGNED 			NOT NULL COMMENT 'id of table turnier',
	`reg_sex` 					CHAR 					NULL COMMENT 'male or female',
	`reg_titel` 				VARCHAR( 30 ) 			NULL COMMENT 'titel as Dr., Prof, etc.',
	`reg_name` 					VARCHAR( 255 ) 			NOT NULL ,
	`reg_vorname` 				VARCHAR( 255 ) 			NOT NULL ,
	`reg_country` 				VARCHAR( 255 ) 			NULL ,
	`reg_city`					VARCHAR( 255 ) 			NULL ,
	`reg_plz`					VARCHAR( 30 ) 			NULL COMMENT 'PO Box',
	`reg_adress` 				VARCHAR( 255 ) 			NULL ,
	`reg_email` 				VARCHAR( 255 ) 			NULL ,
	`reg_phone1` 				VARCHAR( 70 ) 			NULL ,
	`reg_phone2` 				VARCHAR( 70 ) 			NULL ,
	`reg_verband` 				VARCHAR( 255 ) 			NULL COMMENT 'Go Association',
	`reg_date` 					DATETIME 				NOT NULL COMMENT 'date of registration',
	`reg_ip` 					VARCHAR( 255 )			NOT NULL COMMENT 'user ip',
	`reg_update` 				DATETIME 				NOT NULL COMMENT 'date of updating',
	`reg_updateip` 				VARCHAR( 255 )			NOT NULL COMMENT 'ip of the updater',
	`reg_updater` 				VARCHAR( 255 )			NOT NULL COMMENT 'login name of the last updater',
	`reg_mainevent` 			TINYINT ( 1 ) UNSIGNED 	NOT NULL DEFAULT '0'  COMMENT 'registered for the main event',
	`reg_sideevent` 			TINYINT ( 1 ) UNSIGNED 	NOT NULL DEFAULT '0' COMMENT 'registered for the side event',
	`reg_teilnahme` 			TINYINT ( 2 ) UNSIGNED	NOT NULL DEFAULT '1' COMMENT 'parcipitant=1, helper=2, guest=3',
	`reg_accomodation` 			TINYINT ( 1 ) UNSIGNED  NOT NULL DEFAULT '0' COMMENT 'requires accomodation',
	`reg_discount` 				TINYINT ( 1 ) UNSIGNED  NOT NULL DEFAULT '0',
	`reg_discounttype` 			TINYINT ( 2 ) UNSIGNED	NOT NULL DEFAULT '0' COMMENT 'underage:1 student:2',
	`reg_level` 				INT 		 			NOT NULL DEFAULT '0' COMMENT 'negative amounts for kyu, positive for dan',
	`reg_remarks` 				TEXT 					NULL COMMENT 'some comments',
	`reg_uid` 					VARCHAR ( 255 )			NULL COMMENT 'if needed a uid',
	PRIMARY KEY ( `reg_id` ) 
	) TYPE=MyISAM COMMENT = 'parcipitant data, connected to tournament data by id.'; 
	 		
CREATE TABLE turnier (
	`reg_id` 			INT UNSIGNED 				NOT NULL AUTO_INCREMENT ,
	`reg_tournament` 	VARCHAR( 255 ) 				NOT NULL  COMMENT 'e.g. Berlin Open',
	`reg_start` 		DATE 						NULL COMMENT 'start of registration',
	`reg_end`	 		DATE 						NULL COMMENT 'end of registration',
	`reg_target` 		DATE 						NULL COMMENT 'start of tournament',
	`reg_city` 			VARCHAR( 255 ) 				NULL,
	`reg_plz` 			VARCHAR( 10 ) 				NULL COMMENT 'PO BOX e.g. 10357',
	`reg_adress` 		VARCHAR( 255 ) 				NULL,
	`reg_opener` 		VARCHAR( 255 ) 				NULL COMMENT 'login name',
	`reg_ip` 			VARCHAR( 255 ) 				NULL COMMENT 'ip of login name',
	`reg_date` 			DATETIME 					NULL COMMENT 'date of starting this thread',
	`reg_updater` 		VARCHAR( 255 ) 				NULL COMMENT 'login name of the last updater',
	`reg_updateip` 		VARCHAR( 255 ) 				NULL COMMENT 'ip of last updater name',
	`reg_update` 		DATETIME 					NULL COMMENT 'date of updating this thread',
	`reg_open` 			TINYINT ( 1 ) UNSIGNED		NOT NULL DEFAULT '1' COMMENT 'true means active. set to 0 if registration is closed',
	PRIMARY KEY ( `reg_id` ) 
	) TYPE=MyISAM COMMENT = 'tournament data. if open parcitipants are welcomed to register. after registration period this has to be closed to stop further registration.' ;

			
CREATE TABLE config (
	`cfg_id` 			INT UNSIGNED 				NOT NULL AUTO_INCREMENT ,
	`v_sex` 			TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '0' ,
	`v_titel` 			TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '0' ,
	`v_discount` 		TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '0' COMMENT 'view discount',
	`v_accomodation` 	TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '0' COMMENT 'view accomodation',
	`v_sideevent` 		TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '0' COMMENT 'view sideevent',
	`v_helfer` 			TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '0' COMMENT 'view register as helper',
	`v_gast` 			TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '1' COMMENT 'view register as guest',
	`v_phone2` 			TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '0' COMMENT 'view additional phone',
	`v_remarks` 		TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '0' COMMENT 'view remarks',
	`v_level` 			TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '1' COMMENT 'view level',
	`m_level` 			TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '0' COMMENT 'indicates mandatory field',
	`v_verband` 		TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '1' COMMENT 'view association',
	`m_verband` 		TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '1' COMMENT 'indicates mandatory field',
	`v_plz` 			TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '1' COMMENT 'view PO Box',
	`m_plz` 			TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '0' COMMENT 'indicates mandatory field',
	`v_phone1` 			TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '1' COMMENT 'view phone',
	`m_phone1` 			TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '0' COMMENT 'indicates mandatory field',
	`v_country` 		TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '1' COMMENT 'view country',
	`m_country` 		TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '1' COMMENT 'indicates mandatory field',
	`v_adress` 			TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '1' COMMENT 'view adress',
	`m_adress` 			TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '0' COMMENT 'indicates mandatory field',
	`cfg_updater` 		VARCHAR( 255 ) 				NULL COMMENT 'login name of the last updater',
	`cfg_updateip` 		VARCHAR( 255 ) 				NULL COMMENT 'ip of last updater name',
	`cfg_update` 		DATETIME 					NULL COMMENT 'date of updating this thread',
	PRIMARY KEY ( `cfg_id` ) 
	) TYPE=MyISAM COMMENT = 'config data. toggles view and mandatory fields in register formula.' ;

CREATE TABLE email (
	`reg_id` 			INT UNSIGNED 				NOT NULL AUTO_INCREMENT ,
	`reg_mail` 			TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '0' COMMENT 'email after registration',
	`reg_data` 			TINYINT ( 1 ) UNSIGNED 		NOT NULL DEFAULT '0' COMMENT 'including registration data',
	`reg_subject` 		VARCHAR ( 120 ) 			NOT NULL DEFAULT ''  COMMENT 'email subject',
	`reg_name` 			VARCHAR ( 120 ) 			NOT NULL DEFAULT ''  COMMENT 'absender name',
	`reg_abs` 			VARCHAR ( 255 ) 		    NOT NULL DEFAULT ''  COMMENT 'absender email',
	`reg_cc` 			VARCHAR ( 255 )				NOT NULL DEFAULT ''  COMMENT 'carbon copy',
	`reg_bcc` 			VARCHAR ( 255 ) 			NOT NULL DEFAULT ''  COMMENT 'blind carbon copy',
	`reg_url` 			VARCHAR ( 255 ) 			NOT NULL DEFAULT ''  COMMENT 'url to website',
	`reg_updater` 		VARCHAR ( 255 ) 			NULL COMMENT 'login name of the last updater',
	`reg_updateip` 		VARCHAR ( 255 ) 			NULL COMMENT 'ip of last updater name',
	`reg_update` 		DATETIME 					NULL COMMENT 'date of updating this thread',
	PRIMARY KEY ( `reg_id` ) 
	) TYPE=MyISAM COMMENT = 'mail data. configures email confirmation after registration ' ;

